<?php 
defined('BASEPATH') OR exit('No direct script access allowed');


class Login extends CI_Controller
{
    function __construct()
    {
    	parent::__construct();
    }

    public function index()
    {	
    	if($this->session->has_userdata('fcuser_id')){
    		redirect('dashboard','refresh');
    	}
    	$data=array();
    	$data['message'] = '';
    	$csrf = array(
		        'name' => $this->security->get_csrf_token_name(),
		        'hash' => $this->security->get_csrf_hash()
		);

    	if( $this->input->get('status') == 1 ){
    		$data['message'] = $this->alert->warning('Your account has been blocked !!!');
    	}

    	if( $this->input->get('status') == 2 ){
    		$data['message'] = $this->alert->warning('Your login session expired !!!');
    	}

        if( !empty($this->input->get('redirect')) ){
            $data['redirect'] = urlencode($this->input->get('redirect'));
        }else{
            $data['redirect'] = "";
        }

		$data['csrf'] = $csrf;
    	if( $this->input->post('login_submit') && $this->input->server('REQUEST_METHOD') == 'POST' ){
    		
    		extract($_REQUEST);
    		$user = $this->db->escape($user);
    		$pwd = $this->db->escape($pwd);
    		$query = $this->db->query(" SELECT * FROM `fc_users` where user=$user ");
    		$result = $query->row_array();

    		if( $query->num_rows() >0 ){

    			if( $result['status'] == 1 ){

    				$phash = $result['pwd'];

    				if( password_verify(trim($pwd,"'"),$phash) ){

			/*
			  Reset the user login token at every time
			*/

			$token_query = $this->db->query(" SELECT * FROM `fc_user_token` where user_id='".$result['user_id']."' ");
			$utoken = md5(time());

			if( $token_query->num_rows() > 0 ){
				$this->db->query(" update `fc_user_token` set token='$utoken' where 
					user_id='".$result['user_id']."' ");
				$this->session->set_userdata('user_token',$utoken);
			} else {
				$this->db->query(" insert into `fc_user_token` set token='$utoken', user_id='".$result['user_id']."' ");
				$this->session->set_userdata('user_token',$utoken);
			}

			$this->session->set_userdata('fcuser_id',$result['user_id']);
			$this->session->set_userdata('fcadmin_type',$result['admin_type']);

			/*
				maintain login info
			*/
			$this->db->query("insert into `fc_user_login_history` set user_id='".$result['user_id']."'");

            if(empty($redirect)){
                redirect('dashboard','refresh');
            }else{
                redirect(urldecode($redirect),'refresh');
            }
			


    				} else {
    					$message = $this->alert->warning('Please check your password !!!');
    				}

	    		} else {
	    			$message = $this->alert->info('Your account has been blocked !!!');
	    		}

    		} else {
    			$message = $this->alert->warning('Please Check The User Name !!!');
    		}
    		$data['message'] = $message;

    	}
        $this->load->view('login',$data);
    }
}
?>