<?php
defined('BASEPATH') OR exit('No direct script access allowed');
class Order extends MY_Controller
{
	function __construct(){
		parent::__construct();
		$this->load->model(array('order_model','common_model'));
		$this->load->helper('sequency');
	}

	function index(){
		$data['page_title']='Order | DMY';
		$data['message'] = '';		
		$csrf = array(
		        'name' => $this->security->get_csrf_token_name(),
		        'hash' => $this->security->get_csrf_hash()
		);
		$data['csrf']=$csrf;
		$data['user_access']=$this->session->userdata('user_access');

		/*get currency list*/
		$currency_record=array();
		$currency_record['user_restrict'] = false;
		$currency_record['search'] = 0;		
		if( !$this->common_model->verify_user() ){
			$currency_record['user_restrict'] = true;
		}
		if( $this->session->userdata('fcadmin_type') == 1 ){
			$data['currencies'] = $this->common_model->currency_code($currency_record);
		}else{
			$data['currencies'] = $this->order_model->currencies();
		}
		$this->load->model('currency_model');
		$currency_info_arr = $this->currency_model->show('17');
		$data['rate_unit'] = $currency_info_arr['rate_unit'];

		/* Get client list */
		$client_record=array();
		$client_record['user_restrict'] = false;
		if( !$this->common_model->verify_user() ){
			$client_record['user_restrict'] = true;
		}
		$clients=$this->common_model->client_by_group($client_record);
		$this->load->model('client_model');
		foreach ($clients as $client) {
			$clrow = $this->client_model->show($client['client_id']);
			$data['clients'][]=array(
						'client_id'	=> $client['client_id'],
						'title'		=> $client['title'].' - '.$clrow['name']
								);
		}

		$data['suppliers'] = $this->order_model->supplier_list($client_record);

		$data['token'] = md5(time().mt_rand(1000,9999).uniqid());

		$data['order_number']=sequency_order($this->common_model->nextAutoID('fc_order'));
		$data['order_update_status'] = FALSE;
		if( $this->permission->entry_access(7,$this->session->userdata('fcuser_id')) ){
			$data['order_update_status'] = TRUE;
		}

		$this->load->view('order',$data);
	}

	function currency_account($currency_id){

		$this->load->model('dashboard_model');
		if( $currency_id > 1 ){
			$data=$this->dashboard_model->currency_list($currency_id);
			if( count($data) > 0 ){
				echo json_encode($data[0]);
			}else{
				echo json_encode($data);
			}
			
		}

		if( $currency_id == 1 ){
			$record=$this->dashboard_model->rmlist();
			$data=array(
				'fc_value'	=> '-',
				'rm_value'	=> $record['balance'],
				'margin'  	=> '-',
				'currency_id' => 1,
				'rate_unit'	=> 1
			);
			echo json_encode($data);
		}

	}
	

	function insert(){

		$data = array();
		$data['csrf']=$this->security->get_csrf_hash();
		if($this->input->server('REQUEST_METHOD')=='POST' ){

			if( $this->permission->entry_access(6,$this->session->userdata('fcuser_id')) ){

				$supplier_id = $this->input->post('supplier_id');
				$seqnum_rows = $this->common_model->nextId($supplier_id);
				$seqnum_rows+=1;

				$this->load->model('client_model');
				$client_arr_1 = $this->client_model->show( $this->input->post('supplier_id') );
				$code = substr($client_arr_1['client_code'],0,1);
				//$sequence_no = sequency_order_number_1($seqnum_rows,$code);
				$sequence_no = sequency_order_number_2($seqnum_rows,$code);

				$result=$this->order_model->insert($sequence_no);
				if( isset($result['success']) ){

					$data['message']=$this->alert->success($result['success']);
				
				}elseif( isset($result['danger']) ){

					$data['message']=$this->alert->warning($result['danger']);
				}
			}else{
					$data['message']=$this->alert->warning('Permission Denied !!!');
			}

		}else{

			$data['message']=$this->alert->warning('Permission Denied');	
		
		}
		$this->session->set_flashdata('message',$data['message']);
		redirect('order','refresh');
		
	}

	function file_upload(){
		extract($_POST);
		$data = array();
		if($this->input->server('REQUEST_METHOD')=='POST' ){

			if( $this->permission->entry_access(6,$this->session->userdata('fcuser_id')) ){
				
				$this->load->model(array('client_model','currency_model'));
				$currency_arr = $this->currency_model->show($currency_id);
				$rate_unit = ($currency_arr['rate_unit']>0)?$currency_arr['rate_unit']:1;

				$filename=$_FILES['file']['name'];
				$ext=(explode('.',$filename));
				$ext=strtolower(end($ext));
				if($ext=='csv'){
					$file=$_FILES['file']['tmp_name'];
					$record=fopen($file,"r");
					$rows=0;
					$total_insert=0;
					while(($fileup=fgetcsv($record,10000,',')) !== false){
						if( $rows >= 1 ){

							/* sequency no generation */
							$seqnum_rows = $this->common_model->nextId($supplier_id);
							$seqnum_rows+=1;

						$client_arr_1 = $this->client_model->show( $this->input->post('supplier_id') );
						//$code = $client_arr_1['client_code'];
						// $sequence_no = sequency_order_number_1($seqnum_rows,$code);
						$code = substr($client_arr_1['client_code'],0,1);
						$sequence_no = sequency_order_number_2($seqnum_rows,$code);

							$name = $fileup[0];
							$bank_name = $fileup[1];
							$branch_name = $fileup[2];
							$acc_number = $fileup[3];
							$amount = str_replace(",", "",$fileup[4]);
							$rate = str_replace(",", "", $rate);
							$total_rm = ($amount*$rate)/$rate_unit;
							$insertData=array(
								'token'			=> md5(time().mt_rand(1000,9999).uniqid().$rows),
								'otype'			=>	2,
								'txn_order_type'=>	1,
								'currency_id'	=>	$currency_id,
								'supplier_id'	=>	$supplier_id,
								'customer_id'	=>	$customer_id,
								'order_date'	=>	$order_date = date('Y-m-d',strtotime( str_replace('/','-',$order_date) )),
								'order_name'	=>	sequency_order($this->common_model->nextAutoID('fc_order')),
								'name'			=>	$name,
								'bank_name'		=>	$bank_name,
								'branch_name'	=>	$branch_name,
								'acc_number'	=>	$acc_number,
								'amount'		=>	$amount,
								'rate'			=>	$rate,
								'rate_unit'		=>	$rate_unit,
								'total_rm'		=>	$total_rm,
								'created_on'	=>	date('Y-m-d H:i:s'),
								'user_id'		=>	$this->session->userdata('fcuser_id'),
								'sequence_no'	=>	$sequence_no
							);
							$up=$this->db->insert('fc_order',$insertData);
							if( $up ){ ++$total_insert; }
						}
						++$rows;
					}

					$data['message']=$this->alert->success('File uploaded successfully. Totally '.$total_insert.' inserted');

				}else{
					$data['message']=$this->alert->warning('Only CSV File is allowed');
				}

			}else{
					$data['message']=$this->alert->warning('Permission Denied !!!');
			}

		}else{

			$data['message']=$this->alert->warning('Permission Denied');	
		
		}
		$this->session->set_flashdata('message',$data['message']);
		redirect('order','refresh');
		
	}

	function getlist(){
		extract($_REQUEST);
		$this->load->model("common_model");
		$sql="";
		if(!empty($this->input->get('supplier_id'))){
			$sql .=" AND supplier_id='".$this->input->get('supplier_id')."' ";
		}
		if(!empty($this->input->get('customer_id'))){
			$sql .=" AND customer_id='".$this->input->get('customer_id')."' ";
		}
		if(!empty($this->input->get('order_date'))){
			$sql .=" AND order_date='".date('Y-m-d',strtotime(str_replace('/','-',$this->input->get('order_date'))))."' ";
		}
		if(!empty($otype)){
			$sql .=" AND otype='$otype' ";
		}

		if( !$this->common_model->verify_user() ){
			$sql.=" AND user_id=".$this->session->userdata('fcuser_id')."  ";
		}
		$sql.=" AND txn_order_type=1 ";

		$results=$this->order_model->record_list($sql);
		$record['data']=array();
		$sno=0;

		$this->load->model(array('client_model','currency_model'));

		foreach ($results as $result) {

			$otype=($result['otype']==1)?'<span class="badge badge-success" title="Manual Entry">M</span>':'<span class="badge badge-danger" title="File Upload">F</span>';

			$currency_arr = $this->currency_model->show($result['currency_id']);
			$currency_name = $currency_arr['currency_code'];

			$cust_arr = $this->client_model->show($result['customer_id']);
			$cust_code = $cust_arr['client_code'];

			$supp_arr = $this->client_model->show($result['supplier_id']);
			$supp_code = $supp_arr['client_code'];

			$record['data'][]=array(
					'<label class="checkbox checkbox-grey checkbox-ebony">
					    <input type="checkbox" class="order_checked" value="'.$result['order_id'].'" name="order_id[]">
					    <span class="input-span"></span>
					</label>',
					$otype,
					'<span class="badge badge-default">'.$result['sequence_no'].'</span>',
					date('d-M Y',strtotime($result['order_date'])),
					$result['order_name'],
					$currency_name,
					$supp_code,
					$cust_code,
					number_format($result['amount'],2),
					number_format($result['rate'],10),
					number_format($result['total_rm'],2),
					'<a class="update_record badge badge-primary caction" href="javascript:void(0)" data-record_id="'.$result['order_id'].'"><i class="fa fa-edit"></i> ACTION</a>'
			);
		}
		echo json_encode($record);
	}

	function today_order_list($supplier_id){
		
		$this->load->model("common_model");
		$sql=" AND order_date='".date('Y-m-d')."' AND supplier_id='$supplier_id' ";
		$results=$this->order_model->record_list($sql);
		$record['data']=array();
		$sno=0;
		$this->load->model(array('client_model','currency_model'));
		foreach ($results as $result) {

			$currency_arr = $this->currency_model->show($result['currency_id']);
			$currency_name = $currency_arr['currency_code'];

			$cust_arr = $this->client_model->show($result['customer_id']);
			$cust_code = $cust_arr['client_code'];

			$supp_arr = $this->client_model->show($result['supplier_id']);
			$supp_code = $supp_arr['client_code'];

			$record['data'][]=array(
					//$result['order_name'],
					'<span class="badge badge-default">'.$result['sequence_no'].'</span>',
					//$cust_code,
					//$currency_name,
					$result['name'],
					$result['bank_name'],	
					$result['branch_name'],	
					$result['acc_number'],					
					number_format($result['amount'],2),
			);
		}
		echo json_encode($record);
	}

	function view_record($order_id){
		if(isset($order_id)){
			$this->load->model(array('client_model','currency_model'));
			$data['con']=$this->input->get('con');
			$record = $this->order_model->show($order_id);
			$data['record'] = $record;
			$currency_arr = $this->currency_model->show($record['currency_id']);
			$data['currency_name'] = $currency_arr['currency_code'];
			$cust_arr = $this->client_model->show($record['customer_id']);
			$data['cust_code'] = $cust_arr['client_code'];
			$supp_arr = $this->client_model->show($record['supplier_id']);
			$data['supp_code'] = $supp_arr['client_code'];

			/* Get client list */
			$data['clients']=array();
			$data['suppliers']=array();
			$client_record=array();
			$client_record['user_restrict'] = false;
			if( !$this->common_model->verify_user() ){
				$client_record['user_restrict'] = true;
			}
			$clients=$this->common_model->client_by_group($client_record);
			$this->load->model('client_model');
			foreach ($clients as $client) {

				$clrow = $this->client_model->show($client['client_id']);
				$client_selected = ($client['client_id'] == $record['customer_id'])?TRUE:FALSE;
				$supp_selected = ($client['client_id'] == $record['supplier_id'])?TRUE:FALSE;

				$data['clients'][]=array(
							'client_id'	=> $client['client_id'],
							'title'		=> $client['title'].' - '.$clrow['name'],
							'selected'	=> $client_selected
									);

				$data['suppliers'][]=array(
							'client_id'	=> $client['client_id'],
							'title'		=> $client['title'].' - '.$clrow['name'],
							'selected'	=> $supp_selected
									);

			}

			$this->load->view('ajax/getdata.php',$data);
		}
	}

	function order_update(){
		extract($_POST);

		if( !$this->permission->entry_access(7,$this->session->userdata('fcuser_id')) ){
			redirect('dashboard','refresh'); die();
		}
		if($this->input->server('REQUEST_METHOD')=='POST' ){

			$amount=str_replace(",", "", $amount);
			$rate=str_replace(",", "", $rate);
			$total_rm = ($amount*$rate)/$urate_unit;

			$up = $this->db->query(" update `fc_order` SET 
				bank_name= ".$this->db->escape($bank_name).", 
				branch_name= ".$this->db->escape($branch_name).", 
				acc_number =  ".$this->db->escape($acc_number).",
				amount = ".$this->db->escape($amount).",
				rate = ".$this->db->escape($rate).",
				total_rm = ".$this->db->escape($total_rm).", 
				supplier_id = ".$this->db->escape($supplier_id).", 
				customer_id = ".$this->db->escape($customer_id).", 
				updated_on='".date('Y-m-d H:i:s')."' WHERE order_id='$order_id' AND txn_order_type=1 ");
			
			if($up){
				$this->session->set_flashdata('message',$this->alert->success('Order updated successfully. Total RM '.number_format($total_rm,2)) );
			}else{
				$this->session->set_flashdata('message',$this->alert->warning('Something went wrong !!!') );
			}
			
			redirect('order','refresh');
		}
	}


	function confirm_order(){
		$data['con'] = $this->input->post('con');
		$order_array = $this->input->post('order_array');
		$records=$this->order_model->confirm_order($order_array);
		$result=array();
		$this->load->model(array('client_model','currency_model'));
		foreach ($records as $record) {

			$currency_arr = $this->currency_model->show($record['currency_id']);
			$currency_name = $currency_arr['currency_code'];
			$currency_descr =$currency_arr['description'];

			$cust_arr = $this->client_model->show($record['customer_id']);
			$cust_code = $cust_arr['client_code'];
			$client_currency_id = $cust_arr['currency_id'];

			$supp_arr = $this->client_model->show($record['supplier_id']);
			$supplier_currency_id = $supp_arr['currency_id'];

			$cust_arr01 = $this->client_model->client_parent($record['customer_id']);
			$client_group_id = $cust_arr01['parent_id'];

			$currency_arr01 = $this->currency_model->show($client_currency_id);
			$client_currency_rate_unit = $currency_arr01['rate_unit'];

			$supp_currency_arr01 = $this->currency_model->show($supplier_currency_id);
			$supplier_currency_rate_unit = $supp_currency_arr01['rate_unit'];

			$result[]=array(
				'client_id'		=>	$record['customer_id'],
				'client_group_id'=>	$client_group_id,
				'transaction_type'		=>	1,
				'client_currency_id' =>	$client_currency_id,
				'supplier_currency_id'=> $supplier_currency_id,
				'currency_id'	=>	$record['currency_id'],
				'currency_name'	=>	$currency_name,
				'currency_descr'=>	$currency_descr,
				'cust_code'		=>	$cust_code,
				'order_date'	=>	$record['order_date'],
				'amount'		=>	$record['amount'],
				'rate'			=>	$record['rate'],
				'rate_unit'		=>	$record['rate_unit'],
				'total_rm'		=>	$record['total_rm'],
				'order_id'		=>	$record['order_id'],
				'client_currency_rate_unit' => $client_currency_rate_unit,
				'supplier_currency_rate_unit'=> $supplier_currency_rate_unit,
				'supplier_id'	=>	$record['supplier_id'],
				'order_name'	=>	$record['name']
			);
		}
		$data['results'] = $result;
		$this->load->view('ajax/getdata',$data);
	}


	function update_confirmation(){
		extract($_POST);
		$this->load->model("common_model");
		$inserted_records = 0;

		$current_date = date('Y-m-d');
		$settle_close = $this->db->query(" SELECT transaction_date FROM `fc_transaction` WHERE `flag`=0 AND txn_type=2 AND transaction_date<'".$current_date."' AND currency_id !=1  ");
		if( $settle_close->num_rows() > 0 ){
			$this->session->set_flashdata('message',$this->alert->danger('Please ask your <b>Administrator</b> to close the last day Settlement.') );
			redirect('order','refresh');
			die();
		}

		$max_allowed = 50; 
		if( count($order_id) > $max_allowed ){
			$this->session->set_flashdata('message',$this->alert->danger('Can not update more than 10 records at a time !!!') );
			redirect('order','refresh');
			die();
		}
		
		$supp_stock_alert = $settle_not_close_alert = $order_updated_alert = 0;
		//print_r($_POST);
		for ($i = 0; $i < count($order_id); $i++) {
			/* START This page input fields for txn */
			$client_id = ($client_id_1[$i]>0)?$client_id_1[$i]:0;
			$transaction_date = $transaction_date_1[$i];
			$currency_id = ($currency_id_1[$i]>0)?$currency_id_1[$i]:0;
			$currency_code = $currency_name_1[$i];
			//$currency_descr_credit = trim($this->db->escape($currency_descr_credit[$i]),"'");
			$currency_rate_unit = $currency_rate_unit_1[$i];
			$client_currency_rate_unit = ($client_currency_rate_unit_1[$i]>0)?$client_currency_rate_unit_1[$i]:1;
			$supplier_currency_rate_unit = ($supplier_currency_rate_unit_1[$i]>0)?$supplier_currency_rate_unit_1[$i]:1;
			$quantity = $quantity_1[$i];
			$rm_rate = $rm_rate_1[$i];
			$rm_total_rate = $rm_total_rate_1[$i];
			$client_currency_id = ($client_currency_id_1[$i]>0)?$client_currency_id_1[$i]:0;
			$supplier_currency_id = ($supplier_currency_id_1[$i]>0)?$supplier_currency_id_1[$i]:0;
			$supplier_id = ($ssupplier_id[$i]>0)?$ssupplier_id[$i]:0;

			$currency_credit_debit	=	$this->common_model->currency_credit_debit($currency_id);
			$before_stock_credit_m	=	$currency_credit_debit['before_stock_credit_m'];
			$before_stock_debit_m	=	$currency_credit_debit['before_stock_debit_m'];
			$before_credit_rm_m	=	$currency_credit_debit['before_credit_rm_m'];
			$before_debit_rm_m	=	$currency_credit_debit['before_debit_rm_m'];
			$stock_margin_value	=	$currency_credit_debit['stock_margin_value'];

			$error = 0;
			$order_res = $this->db->query(" SELECT order_id FROM `fc_transaction` where order_id='".$order_id[$i]."' ");

		$settle_close = $this->db->query(" SELECT transaction_date FROM `fc_transaction` 
			WHERE `flag`=0 AND txn_type=2 AND 
			transaction_date < '".date('Y-m-d',strtotime(str_replace('/','-',$transaction_date)))."' 
			AND currency_id !=1  ");

			if( $order_res->num_rows() > 0 || 
				$supplier_currency_id == 0 || 
				$client_currency_id == 0	||
				$client_id == 0 ||
				$supplier_id == 0 || $currency_id == 0 || $settle_close->num_rows() > 0 ) { ++$error; }
			/* END This page input fields for txn */
			$credit_query_status=$debit_query_status=0;

			if($settle_close->num_rows() > 0 ){ ++$settle_not_close_alert; }
			if($order_res->num_rows()){ ++$order_updated_alert; }


			###################### START CREDIT METHOD ######################

			// Client credit debit details
			$client_credit_debit	=	$this->common_model->client_credit_debit($ssupplier_id[$i]);
			$before_fc_credit_c		=	$client_credit_debit['before_fc_credit_c'];
			$before_fc_debit_c		=	$client_credit_debit['before_fc_debit_c'];
			$before_rm_credit_c		=	$client_credit_debit['before_rm_credit_c'];
			$before_rm_debit_c		=	$client_credit_debit['before_rm_debit_c'];
			$transaction_type = 1;

			$token = md5(time().mt_rand(1000,9999).uniqid().$i);
			$sequence_no=sequency_transaction($this->common_model->nextAutoID('fc_transaction'));


			if( $supplier_currency_id == 1 ){
				$fc_rate=$fc_convert=$fc_total_rate=0;
				
				$client_accin_res = $this->common_model->client_account($ssupplier_id[$i],2);
				if(abs($client_accin_res['fc_convert']) > 0) {
					$rm_rate=$client_accin_res['fc_convert'];
					$system_convert = $rm_rate;
				}else{
					$rm_rate = $rm_rate;
					$system_convert = $rm_rate;
				}
				$currency_rate_unit = ($currency_rate_unit>0)?$currency_rate_unit:1;
				$qty_unit = $quantity/$currency_rate_unit;
				$rm_total_rate = round( ($rm_rate*$qty_unit),2 );
				// delete purpose if query failed
				$d_rm_total_rate=$rm_total_rate;
				$d_fc_total_rate=$fc_total_rate;
			}

			if( $supplier_currency_id != 1 ){
				$client_accin_res = $this->common_model->client_account($ssupplier_id[$i],2);
				$fc_rate = 1;
				if(abs($client_accin_res['fc_convert']) > 0) {
					$fc_convert=$client_accin_res['fc_convert'];
					$system_convert = $fc_convert;
				}else{
					$fc_convert = $rm_rate;
					$system_convert = $fc_convert;
				}

				$rm_rate = round( ($fc_rate*$fc_convert),10);
				$stock_margin_value_01 = $rm_rate;
				$currency_rate_unit = ($currency_rate_unit>0)?$currency_rate_unit:1;
				$amountA = $quantity/$currency_rate_unit;
				$rm_total_rate = round( ($amountA*$rm_rate),2);
				$fc_total_rate=round( ($amountA*$fc_rate),2);
				// delete purpose if query failed
				$d_rm_total_rate=$rm_total_rate;
				$d_fc_total_rate=$fc_total_rate;
			}

		// Show alert if stock is not available 
		// $supp_stock_res=$this->common_model->client_account($supplier_id,2);
		// $supp_stock_res = $this->db->query(" SELECT * FROM `fc_client_account` 
		// 	where client_id=$supplier_id ");
		// $supp_stock_row= $supp_stock_res->row_array();
		//$supp_stock_value = $this->order_model->supplier_account_info($supplier_id);

		//if($supp_stock_value < $quantity){ ++$error; ++$supp_stock_alert; }

			$data = array(
				'transaction_reference' => $sequence_no,
				'client_id'				=> $supplier_id,
				'transaction_date'		=> date('Y-m-d',strtotime(str_replace('/','-',
											$transaction_date))),
				'txn_type'				=> $transaction_type,
				'currency_id'			=> $currency_id,
				'currency_name'			=> $currency_code,
				'currency_descr'		=> trim($this->db->escape($currency_descr_1[$i]),"'"),
				'currency_rate_unit'	=> $currency_rate_unit,
				'client_currency_rate_unit' => $supplier_currency_rate_unit,
				'quantity'				=> $quantity,
				'rm_rate'				=> $rm_rate,
				'rm_total_rate'			=> $rm_total_rate,
				'fc_rate'				=> $fc_rate,
				'fc_convert'			=> $fc_convert,
				'system_convert'		=> $system_convert,
				'fc_total_rate'			=> $fc_total_rate,
				'created_at'			=> date('Y-m-d H:i:s'),
				'user_id'				=> $this->session->userdata('fcuser_id'),
				'before_fc_credit_c'	=> $before_fc_credit_c,
				'before_fc_debit_c'		=> $before_fc_debit_c,
				'before_rm_credit_c'	=> $before_rm_credit_c,
				'before_rm_debit_c'		=> $before_rm_debit_c,
				'before_stock_credit_m'	=> $before_stock_credit_m,
				'before_stock_debit_m'	=> $before_stock_debit_m,
				'before_credit_rm_m'	=> $before_credit_rm_m,
				'before_debit_rm_m'		=> $before_debit_rm_m,
				'stock_margin_value'    => $stock_margin_value,
				'stock_margin_value_1'	=> $stock_margin_value,
				'token'					=> $token,
				'order_id'				=> $order_id[$i],
				'txn_order'				=> 2
			);

			if( $error == 0 ){
				$up = $this->db->insert("fc_transaction",$data);
				if($up) {
					++$credit_query_status;
					$transaction_id=$this->db->insert_id();
					$credit_transaction_id = $transaction_id;
					$client_account_res = $this->db->query(" SELECT client_id FROM `fc_client_account` 
					where client_id='$supplier_id' and currency_id='$supplier_currency_id' ");

					if( $client_account_res->num_rows() > 0 ){ // update

						$this->db->query(" update fc_client_account set 
								rm_credit=rm_credit+$rm_total_rate, 
								fc_credit=fc_credit+$fc_total_rate
								where client_id='$supplier_id' and currency_id='$supplier_currency_id'
								");	

					} else { // create
					
						$this->db->query(" insert into fc_client_account set 
									rm_credit=$rm_total_rate, 
									fc_credit=$fc_total_rate,
									client_id='$supplier_id', 
									currency_id='$supplier_currency_id'
								");

					}
				}
			}

			###################### END CREDIT METHOD ########################


			###################### START DEBIT METHOD #######################
			$rm_rate = $rm_rate_1[$i];

			// Client credit debit details
			$client_credit_debit	=	$this->common_model->client_credit_debit($client_id);
			$before_fc_credit_c		=	$client_credit_debit['before_fc_credit_c'];
			$before_fc_debit_c		=	$client_credit_debit['before_fc_debit_c'];
			$before_rm_credit_c		=	$client_credit_debit['before_rm_credit_c'];
			$before_rm_debit_c		=	$client_credit_debit['before_rm_debit_c'];
			$transaction_type = 2;

			if( $client_currency_id_1[$i] == 1 ){
				$fc_rate=$fc_convert=$fc_total_rate=0;
				$currency_rate_unit = ($currency_rate_unit>0)?$currency_rate_unit:1;
				$qty_unit = $quantity/$currency_rate_unit;
				$rm_total_rate = round( ($rm_rate*$qty_unit),2 );
				// delete purpose if query failed
				//$d_rm_total_rate=$rm_total_rate;
				//$d_fc_total_rate=$fc_total_rate;
			}

			if( $client_currency_id_1[$i] != 1 ){
				//$client_accin_res = $this->common_model->client_account($ssupplier_id[$i],2);
				$fc_rate = 1;
				//$fc_convert=$client_accin_res['fc_convert'];
				//$rm_rate = round( ($fc_rate*$fc_convert),10);
				$fc_convert = $rm_rate;
				$currency_rate_unit = ($currency_rate_unit>0)?$currency_rate_unit:1;
				$amountA = $quantity/$currency_rate_unit;
				$rm_total_rate = round( ($amountA*$rm_rate),2);
				$fc_total_rate=round( ($amountA*$fc_rate),2);
				// delete purpose if query failed
				//$d_rm_total_rate=$rm_total_rate;
				//$d_fc_total_rate=$fc_total_rate;
			}


			$token = md5(time().mt_rand(1000,9999).uniqid().$i);
			$sequence_no=sequency_transaction($this->common_model->nextAutoID('fc_transaction'));

			$data = array(
				'transaction_reference' => $sequence_no,
				'client_id'				=> $client_id,
				'transaction_date'		=> date('Y-m-d',strtotime(str_replace('/','-',
											$transaction_date))),
				'txn_type'				=> $transaction_type,
				'currency_id'			=> $currency_id,
				'currency_name'			=> $currency_code,
				'currency_descr'		=> trim($this->db->escape($currency_descr_1[$i]),"'"),
				'currency_rate_unit'	=> $currency_rate_unit,
				'client_currency_rate_unit' => $client_currency_rate_unit,
				'quantity'				=> $quantity,
				'rm_rate'				=> $rm_rate,
				'rm_total_rate'			=> $rm_total_rate,
				'fc_rate'				=> $fc_rate,
				'fc_convert'			=> $fc_convert,
				'system_convert'		=> $system_convert,
				'fc_total_rate'			=> $fc_total_rate,
				'created_at'			=> date('Y-m-d H:i:s'),
				'user_id'				=> $this->session->userdata('fcuser_id'),
				'before_fc_credit_c'	=> $before_fc_credit_c,
				'before_fc_debit_c'		=> $before_fc_debit_c,
				'before_rm_credit_c'	=> $before_rm_credit_c,
				'before_rm_debit_c'		=> $before_rm_debit_c,
				'before_stock_credit_m'	=> $before_stock_credit_m,
				'before_stock_debit_m'	=> $before_stock_debit_m,
				'before_credit_rm_m'	=> $before_credit_rm_m,
				'before_debit_rm_m'		=> $before_debit_rm_m,
				'stock_margin_value'    => $stock_margin_value,
				'stock_margin_value_1'	=> $stock_margin_value_01,
				'token'					=> $token,
				'order_id'				=> $order_id[$i],
				'txn_order'				=> 2
			);

			if( $error == 0 && $credit_query_status == 1 ){
				$up = $this->db->insert("fc_transaction",$data);
				if($up) {
					++$debit_query_status;
					$transaction_id=$this->db->insert_id();
					$debit_transaction_id=$transaction_id;
					$client_account_res = $this->db->query(" SELECT client_id FROM `fc_client_account` 
					where client_id='$client_id' and currency_id='$client_currency_id' ");

					if( $client_account_res->num_rows() > 0 ){ // update

						$this->db->query(" update fc_client_account set 
								rm_debit=rm_debit+$rm_total_rate, 
								fc_debit=fc_debit+$fc_total_rate
								where client_id='$client_id' and currency_id='$client_currency_id'
								");	

					} else { // create
					
						$this->db->query(" insert into fc_client_account set 
									rm_debit=$rm_total_rate, 
									fc_debit=$fc_total_rate,
									client_id='$client_id', 
									currency_id='$client_currency_id'
								");

					}
				} else { // if txn failed
					// Remove Previous txn details & Client Account info
					$this->db->query(" DELETE FROM `fc_transaction` WHERE transaction_id='$credit_transaction_id' ");
					$this->db->query(" update fc_client_account set 
								rm_credit=rm_credit-$d_rm_total_rate, 
								fc_credit=fc_credit-$d_fc_total_rate
								where client_id='$supplier_id' and currency_id='$supplier_currency_id'
								");	
				}
			}

			###################### END DEBIT METHOD #########################
			if( $credit_query_status == 1 && $debit_query_status == 1 ) {
				++$inserted_records;
			/* update order status */
			$this->db->query(" update `fc_order` set txn_order_type=2 where order_id='".$order_id[$i]."' ");

			// update txn status to one if credit & debit record inserted
			$this->db->query(" UPDATE `fc_transaction` SET txn_order=1 WHERE transaction_id='$credit_transaction_id' OR transaction_id='$debit_transaction_id' ");

			}

			if( $error > 0 ){
				if( $supp_stock_alert > 0 ){
					$this->session->set_flashdata('message_alert',$this->alert->danger('Some Records not updated because of insufficient balance !!!') );
				} elseif ($settle_not_close_alert > 0) {
					$this->session->set_flashdata('message_alert',$this->alert->danger('Not able to move some records because ADMIN Closed the Settlement on given date !!!') );
				} elseif ($order_updated_alert) {
					$this->session->set_flashdata('message_alert',$this->alert->danger('Some Records not updated because it already moved to Transaction !!!') );
				}else{
					$this->session->set_flashdata('message_alert',$this->alert->danger('Unable to process your request. Please try later !!!') );
				}

				break;
			}

		}

		if($inserted_records > 0){
		
		$this->db->query(" INSERT INTO `fc_notification` (`link_type`, `ntype`, `description`, `user_id`, `is_read`, `notify_to`, `created_at`) VALUES ('0', '1', '".$this->profile_info['name']." - added ".$inserted_records." Transactions ', '".$this->session->userdata('fcuser_id')."', '0', '1', '".date('Y-m-d H:i:s')."'); ");

		$this->session->set_flashdata('message',$this->alert->success('Order moved to Transaction successfully. Totally '.$inserted_records.' Record Moved') );

		}else{
			
			$this->session->set_flashdata('message',$this->alert->danger('Unable to process your request. Please try later !!!') );
		}
		
		redirect('order','refresh');

	}

	function supplier_account($supplier_id){
		$currency_id = $this->input->get('currency_id');
		$datas = $this->order_model->supplier_account($supplier_id,$currency_id);
		foreach ($datas as $data) {
			if($data['txn_type'] == 1) {
				$fc_amount_credit = $data['fc_amount'];
				$rm_amount_credit = $data['rm_amount'];
			}
			if($data['txn_type'] == 2) {
				$fc_amount_debit = $data['fc_amount'];
				$rm_amount_debit = $data['rm_amount'];
			}
		} 
		$rm_amount = $rm_amount_debit - $rm_amount_credit;
		$fc_amount = $fc_amount_debit - $fc_amount_credit;
		$conv = ($fc_amount > 0 || $fc_amount < 0)?abs($rm_amount/$fc_amount):0;
		$rdata['account']=array(
			'rm_amount'		=>	number_format($rm_amount,2),
			'fc_amount'		=>	number_format($fc_amount,2),
			'conv'			=>	number_format($conv,10),
		);
		echo json_encode($rdata);
	}

	function supplier_stock($supplier_id){
		$currency_id = $this->input->get('currency_id');
		$datas = $this->order_model->supplier_stock($supplier_id,$currency_id);
		foreach ($datas as $data) {
			if($data['txn_type'] == 1) {
				$quantity_credit = $data['quantity'];
			}
			if($data['txn_type'] == 2) {
				$quantity_debit = $data['quantity'];
			}
		} 
		$stock = $quantity_credit - $quantity_debit;
		$rdata['account']=array(
			'stock'		=>	number_format($stock,2)
		);
		echo json_encode($rdata);
	}

	function delete($order_id){
		//$delete_type = 1 single delete
		if($this->input->server('REQUEST_METHOD')=='GET' ){
			if( $this->permission->modify_access(6,$this->session->userdata('fcuser_id')) ){
				$result=$this->order_model->delete($order_id,$delete_type = 1);
				if( isset($result['success']) ){
					$message_status=$this->alert->success($result['success']);
				}elseif( isset($result['danger']) ){
					$message_status=$this->alert->danger($result['danger']);
				}
			}else{
					$message_status=$this->alert->danger('Permission Denied !!!');
			}
			echo $message_status;
		}
	}

	function bulk_delete(){
		//$delete_type = 2 bulk delete
		if( $this->permission->modify_access(6,$this->session->userdata('fcuser_id')) ){
			$array_ids = implode(',',$this->input->post('order_array'));
			$result=$this->order_model->delete($array_ids,$delete_type = 2);
			if( isset($result['success']) ){
				$this->session->set_flashdata('message',$this->alert->success($result['success']) );
			}elseif( isset($result['danger']) ){
				$this->session->set_flashdata('message',$this->alert->success($result['danger']) );
			}
		}else{
			$this->session->set_flashdata('message',$this->alert->danger('Permission Denied !!!') );
			redirect('order','refresh');
		}
	}

}
?>