<?php
defined('BASEPATH') OR exit('No direct script access allowed');
class Profile extends MY_Controller
{
	function __construct(){
		parent::__construct();
		$this->load->model('profile_model');
	}

	function index(){
		$data['page_title']='Profile';
		$data['message']='';
		if($this->input->server('REQUEST_METHOD')=='POST' ){
			$result=$this->profile_model->profile_update();
			if( isset($result['success']) ){
				$message_status=$this->alert->success($result['success']);
			}elseif( isset($result['danger']) ){
				$message_status=$this->alert->warning($result['danger']);
			}
			$data['message']=$message_status;
		}

		$csrf = array(
		        'name' => $this->security->get_csrf_token_name(),
		        'hash' => $this->security->get_csrf_hash()
		);
		$data['csrf']=$csrf;
		$data['record']=$this->profile_model->profile_info();
		$data['user_access']=$this->session->userdata('user_access');
		$this->load->view('profile',$data);
	}

}
?>