<?php
defined('BASEPATH') OR exit('No direct script access allowed');
class Report extends MY_Controller
{
	function __construct(){
		parent::__construct();
		$this->load->model(array('client_model','currency_model','common_model','order_model'));
	}

	function index(){
		$data = array();
		$data['page_title'] = 'Report';
		$data['user_access']=$this->session->userdata('user_access');
		$currencies =array();
		$data['settlement_permission'] = FALSE;
		if( $this->session->userdata('fcadmin_type') == 1 ){
			$data['settlement_permission'] = TRUE;
			$currencies_array = $this->currency_model->record_list();
			foreach ($currencies_array as $value) {
				$currencies[] = array(
									'currency_id' => $value['currency_id'],
									'title'		  => $value['currency_code']
								);
			}
			$data['currencies'] = $currencies;
		}else{

			$Cur_query=$this->db->query(" SELECT * FROM `fc_currency` where currency_id IN ( SELECT id FROM `fc_user_currency_client_group` WHERE atype=1 AND user_id=".$this->session->userdata('fcuser_id')." ) ORDER BY currency_code ");
			$data['currencies']=array();
			foreach ($Cur_query->result_array() as $value_1) {
				$data['currencies'][] = array(
									'currency_id' => $value_1['currency_id'],
									'title'		  => $value_1['currency_code']
								);
			}
			
		}

		/* Get client list */
		$client_record=array();
		$client_record['user_restrict'] = false;
		if( !$this->common_model->verify_user() ){
			$client_record['user_restrict'] = true;
		}
		$clients=$this->common_model->client_by_group($client_record);
		$this->load->model('client_model');
		foreach ($clients as $client) {
			$clrow = $this->client_model->show($client['client_id']);
			$data['clients'][] = array(
						'client_id'	=> $client['client_id'],
						'title'		=> $client['title'].' - '.$clrow['name']
								);
		}

		// Client group
		$client_group = array();
		$client_group_sql = '';
		if( !$this->common_model->verify_user() ){
			$client_group_sql.=" and client_id IN ( SELECT id FROM `fc_user_currency_client_group` WHERE atype=0 AND user_id=".$this->session->userdata('fcuser_id')." ) ";
		}
		$query=$this->db->query(" SELECT * FROM `fc_clients` where 1 ".$client_group_sql." group by client_group order by client_group");
		foreach ($query->result_array() as $value) {
						
			$client_group[]=array(
				'client_id' => $value['client_id'],
				'title' => htmlentities($value['client_group'])
			);
		}
		$data['client_groups'] = $client_group;
		$this->load->model('order_model');
		$data['suppliers'] = $this->order_model->supplier_list($client_record);

		$data['tab'] = (!empty($this->input->get('tab')))?$this->input->get('tab'):'';

		$this->load->view('report/report',$data);
	}

	function client_account_info($client_id=0){
		$data = array();
		$record=$this->client_model->show($client_id);
		$data['client']=$record;
		$currency_arr = $this->currency_model->show($record['currency_id']);
		$data['currency_name'] = $currency_arr['currency_code'];
		$data['account'] = $this->common_model->client_account($client_id,2);

		echo json_encode($data);
	}

	function client_account_view($client_id=0){
		$data = array();
		$data['page_title'] = 'Client Account Info & Transaction List';

		$record=$this->client_model->show($client_id);
		$data['result']=$record;
		$currency_arr = $this->currency_model->show($record['currency_id']);
		$data['currency_name'] = $currency_arr['currency_code'];
		$data['account'] = $this->common_model->client_account($client_id,2);
		echo $this->load->view('report/client_account',$data,true);
	}

	function currency_account_view($currency_id=0){
		$data = array();
		$currency_stock=array();
		$this->load->model('dashboard_model');
		if( $currency_id > 1 ){
			$stock_array=$this->dashboard_model->currency_list($currency_id);
			if( count($stock_array) > 0 ){
				$currency_stock=$stock_array[0];
			}else{
				$currency_stock=$stock_array;
			}
		}
		if( $currency_id == 1 ){
			$record=$this->dashboard_model->rmlist();
			$currency_stock=array(
				'fc_value'	=> '0',
				'rm_value'	=> $record['balance'],
				'margin'  	=> '0',
				'currency_id' => 1,
				'rate_unit'	=> 1
			);
		}
		$data['currency_stock'] = $currency_stock;
		$currency_arr = $this->currency_model->show($currency_id);
		$data['currency_name'] = $currency_arr['currency_code'];
		$data['currency_id'] = $currency_id;
		$this->load->view('report/currency_account',$data);
	}

	function client_txn_list($client_id=0){

		$sql="";
		if( $this->session->userdata('fcadmin_type') != 1 ){
		//	$sql.=" AND user_id=".$this->session->userdata('fcuser_id');
		}
		if( $client_id > 0 ){
			$sql.=" AND client_id = ".$this->db->escape($client_id); 
		}
		if( $this->input->get('currency_id') > 0 ){
			$sql.=" AND currency_id = ".$this->db->escape($this->input->get('currency_id')); 
		}
		if( $this->input->get('filter_type') == 1 || $this->input->get('filter_type') == 2 ){
			$sql.=" AND txn_type=".$this->db->escape($this->input->get('filter_type'))." ";
		}
		$view_type=$this->input->get('view_type');

		if( !empty($this->input->get('from_date')) && !empty($this->input->get('to_date'))  ){
			$from_date = date('Y-m-d',strtotime(str_replace('/','-',$this->input->get('from_date'))));
			$to_date = date('Y-m-d',strtotime(str_replace('/','-',$this->input->get('to_date'))));
			$sql.=" AND transaction_date between '$from_date' AND '$to_date' ";
		}
		$query=$this->db->query(" SELECT * FROM `fc_transaction` where 1 ".$sql." order by transaction_id desc ");
		$results=$query->result_array();

		$record['data']=array();
		$sno=0;
		
		foreach ($results as $result) {

			$txn_type=($result['txn_type']==1)?'<span class="badge badge-success">Credit</span>':'<span class="badge badge-danger">Debit</span>';
			$currency_arr = $this->currency_model->show($result['currency_id']);
			$currency_name = $currency_arr['currency_code'];

			$client=$this->client_model->show($result['client_id']);
			$client_code=$client['client_code'];
			$client_currency_id = $client['currency_id'];

			$fc_credit_c=$rm_credit_c=$fc_debit_c=$rm_debit_c=$fc_total_balance=$rm_total_balance=0;
			$stock_res01 = $this->db->query(" SELECT SUM(rm_total_rate) AS rm_total_rate,SUM(fc_total_rate) AS fc_total_rate,txn_type FROM `fc_transaction` where `transaction_id` <= ".$result['transaction_id']." AND 
				client_id='".$result['client_id']."' GROUP BY txn_type ");
			$stock_row01 = $stock_res01->result_array();
			foreach ($stock_row01 as $stock_value) {
				if($stock_value['txn_type'] == 1){
					$fc_credit_c += $stock_value['fc_total_rate'];
					$rm_credit_c += $stock_value['rm_total_rate'];
				}
				if($stock_value['txn_type'] == 2){
					$fc_debit_c += $stock_value['fc_total_rate'];
					$rm_debit_c += $stock_value['rm_total_rate'];
				}	
			}
					
			$fc_total_balance = $fc_debit_c-$fc_credit_c;
			$rm_total_balance = $rm_debit_c-$rm_credit_c;


			if( $view_type == 1 ){
				$credit_amt_1 = $debit_amt_1 = $remaining_bal_rm = $remaining_bal_fc = $fc_rm_rate = 0;
				if($client_currency_id == 1){
				    $fc_rm_rate = $result['rm_rate'];
				    if($result['txn_type'] == 1){
						$credit_amt_1 = $result['rm_total_rate'];
					}else{
						$debit_amt_1 = $result['rm_total_rate'];
					}
				}else{
				    $fc_rm_rate = $result['fc_rate'];
				    if($result['txn_type'] == 1){
						$credit_amt_1 = $result['fc_total_rate'];
					}else{
						$debit_amt_1 = $result['fc_total_rate'];
					}
				}
				//if($client_currency_id == 1){
					
					$remaining_bal_rm = $rm_total_balance;
					
				//}else{
				
					$remaining_bal_fc = $fc_total_balance;
					
			//	}
				
				
				$record['data'][]=array(
						'<span class="badge badge-default">'.$result['transaction_reference'].'</span>',
						date('d-M y',strtotime($result['transaction_date'])),
						$txn_type,
						$result['currency_descr'],
						$currency_name,
						number_format($result['quantity'],2),
						number_format($fc_rm_rate,5),
						number_format($credit_amt_1,2),
						number_format($debit_amt_1,2),
						number_format($rm_total_balance,2),
						number_format($fc_total_balance,2)
						);
						
				// find the opening balance
				$first_query=$this->db->query(" SELECT transaction_id FROM `fc_transaction` where 1 ".$sql." order by transaction_id ASC LIMIT 1 ")->row_array();
				if($first_query['transaction_id'] == $result['transaction_id']){
				    if($client_currency_id == 1){
				    $open_bal_q = $this->db->query(" select (sum(coalesce((case when (`txn_type` = '2') then `rm_total_rate` end),0)) - sum(coalesce((case when (`txn_type` = '1') then `rm_total_rate` end),0))) AS `balance` from `fc_transaction` WHERE client_id=".$this->db->escape($client_id)." AND transaction_id <  ".$first_query['transaction_id'])->row_array();
				    }else{
				    $open_bal_q = $this->db->query(" select (sum(coalesce((case when (`txn_type` = '2') then `fc_total_rate` end),0)) - sum(coalesce((case when (`txn_type` = '1') then `fc_total_rate` end),0))) AS `balance` from `fc_transaction` WHERE client_id=".$this->db->escape($client_id)." AND transaction_id <  ".$first_query['transaction_id'])->row_array();
				    }
				    
				    $open_bal_q = $this->db->query(" select (sum(coalesce((case when (`txn_type` = '2') then `rm_total_rate` end),0)) - sum(coalesce((case when (`txn_type` = '1') then `rm_total_rate` end),0))) AS `balance_rm`, (sum(coalesce((case when (`txn_type` = '2') then `fc_total_rate` end),0)) - sum(coalesce((case when (`txn_type` = '1') then `fc_total_rate` end),0))) AS `balance_fc` from `fc_transaction` WHERE client_id=".$this->db->escape($client_id)." AND transaction_id <  ".$first_query['transaction_id'])->row_array();
				    
				    $record['data'][] = ['', '', '', '', '', '', '', '', 'Prev Bal', number_format($open_bal_q['balance_rm'],2), number_format($open_bal_q['balance_fc'],2)];
				}
			}

			if( $view_type == 2 ){
				$record['data'][]=array(
						'<span class="badge badge-default">'.$result['transaction_reference'].'</span>',
						date('d-M y',strtotime($result['transaction_date'])),
						$txn_type,
						$result['currency_descr'],
						$currency_name,
						$client_code,
						number_format($result['quantity'],2),
						number_format($result['fc_rate'],5),
						number_format($result['fc_total_rate'],2),
						//number_format($fc_total_balance,2),
						number_format($result['rm_rate'],5),
						number_format($result['rm_total_rate'],2),
						//number_format($rm_total_balance,2),
						);
			}

			if( $view_type == 3 ){
			    
			    $balance_stock_qty = $stock_qty_credit_c = $stock_qty_debit_c = $stock_qty_rm_bal = $stock_qty_rm_c=$stock_qty_rm_d=0; 
			    $balance_stock_res = $this->db->query(" SELECT SUM(quantity) AS quantity,SUM(rm_total_rate) AS rm_total_rate,txn_type FROM `fc_transaction` where `transaction_id` <= ".$result['transaction_id']." AND 
				currency_id='".$result['currency_id']."' GROUP BY txn_type ");
    			$balance_stock_row = $balance_stock_res->result_array();
    			foreach ($balance_stock_row as $balance_stock_row1) {
    				if($balance_stock_row1['txn_type'] == 1){
    					$stock_qty_credit_c += $balance_stock_row1['quantity'];
    					$stock_qty_rm_c += $balance_stock_row1['rm_total_rate'];
    				}
    				if($balance_stock_row1['txn_type'] == 2){
    					$stock_qty_debit_c += $balance_stock_row1['quantity'];
    					$stock_qty_rm_d += $balance_stock_row1['rm_total_rate']; 
    				}	
    			}
    			$balance_stock_qty = $stock_qty_credit_c-$stock_qty_debit_c;
			    $stock_qty_rm_bal = $stock_qty_rm_c-$stock_qty_rm_d;
				$record['data'][]=array(
						'<span class="badge badge-default">'.$result['transaction_reference'].'</span>',
						date('d-M y',strtotime($result['transaction_date'])),
						$txn_type,
						$result['currency_descr'],
						$currency_name,
						$client_code,
						number_format($result['quantity'],2),
						number_format($balance_stock_qty,2),
						number_format($result['fc_rate'],5),
						number_format($result['fc_total_rate'],2),
						number_format($result['rm_rate'],5),
						number_format($result['rm_total_rate'],2),
						);
			}
			
			
			if( $view_type == 4 ){
				$record['data'][]=array(
						'<span class="badge badge-default">'.$result['transaction_reference'].'</span>',
						date('d-M y',strtotime($result['transaction_date'])),
						$txn_type,
						$result['currency_descr'],
						$currency_name,
						number_format($result['quantity'],2),
						number_format($result['fc_rate'],5),
						number_format($result['fc_total_rate'],2),
						number_format($fc_total_balance,2),
						number_format($result['rm_rate'],5),
						number_format($result['rm_total_rate'],2),
						number_format($rm_total_balance,2),
						);
			}

			
		}
		echo json_encode($record);
	}


	function order_list(){
		extract($_REQUEST);
		$sql="";
		if( $this->session->userdata('fcadmin_type') != 1 ){
		//	$sql.=" AND user_id=".$this->session->userdata('fcuser_id');
		}
		if( $this->input->get('supplier_id') > 0 ){
			$sql.=" AND supplier_id = ".$supplier_id; 
		}
		if( $this->input->get('customer_id') > 0 ){
			$sql.=" AND customer_id = ".$customer_id; 
		}
		if( $this->input->get('currency_id') > 0 ){
			$sql.=" AND currency_id = ".$this->input->get('currency_id'); 
		}
		if( $this->input->get('filter_type') == 1 || $this->input->get('filter_type') == 2 ){
			$sql.=" AND txn_type='".$this->input->get('filter_type')."' ";
		}

		if( $this->input->get('acc_no') != '' ){
			$sql.=" AND acc_number='".$this->input->get('acc_no')."' ";
		}

		if( !empty($this->input->get('from_date')) && !empty($this->input->get('to_date'))  ){
			$from_date = date('Y-m-d',strtotime(str_replace('/','-',$this->input->get('from_date'))));
			$to_date = date('Y-m-d',strtotime(str_replace('/','-',$this->input->get('to_date'))));
			$sql.=" AND order_date between '$from_date' AND '$to_date' ";
		}
		$query=$this->db->query(" SELECT * FROM `fc_order` where 1 ".$sql." order by order_id desc ");
		$results=$query->result_array();
		$record['data']=array();

	foreach ($results as $result) {
		$status=($result['txn_order_type']==1)?'<span class="badge badge-danger">Not Yet</span>':'<span class="badge badge-success">Updated</span>';
		$currency_arr = $this->currency_model->show($result['currency_id']);
		$currency_name = $currency_arr['currency_code'];

		$supplier=$this->client_model->show($result['supplier_id']);
		$supplier_code=$supplier['client_code'];

		$customer=$this->client_model->show($result['customer_id']);
		$customer_code=$customer['client_code'];


		$record['data'][]=array(
				date('d-M y',strtotime($result['order_date'])),
				$result['sequence_no'],
				$result['order_name'],
				$currency_name,
				$supplier_code,
				$customer_code,
				htmlentities($result['name']),
				htmlentities($result['bank_name']),
				htmlentities($result['branch_name']),
				$result['acc_number'],
				number_format($result['amount'],2),
				number_format($result['rate'],5),
				number_format($result['total_rm'],2),
				$status
			);
	}
		echo json_encode($record);

	}


	function client_report_list()
	{	
		
		$data = array();
		$data['excel_option'] = 0;
		$client_id = $this->input->get('client_id');
		$client_group_id = $this->input->get('client_group_id');
		
		if( $this->input->get('excel_option') == 1 ){
			$data['excel_option'] = 1;
		}
		$sql="";
		if( $this->session->userdata('fcadmin_type') != 1 ){
			//$sql.=" AND user_id=".$this->session->userdata('fcuser_id');
		}
        // if( !empty($client_group_id) ){
        //     $sql .= " AND client_id IN ( SELECT client_id FROM `fc_client_code` WHERE parent_id=".$client_group_id." ) ";
        // }
        // if( !empty($client_id) ){
        //     $sql .= " AND client_id=".$client_id;
        // }
        if( !empty($this->input->get('currency_id')) ){
            $sql .= " AND currency_id=".$this->input->get('currency_id');
        }
        if( !empty($this->input->get('from_date')) && !empty($this->input->get('to_date')) ){
            $from_date = date('Y-m-d',strtotime(str_replace('/','-',$this->input->get('from_date'))));
			$to_date = date('Y-m-d',strtotime(str_replace('/','-',$this->input->get('to_date'))));
			$sql.=" AND transaction_date between '$from_date' AND '$to_date' ";
        }
        
        if($this->input->get('mngr') == 1){
            $from_date = date('Y').'-'.$this->input->get('mnth').'-01';
            $to_date = date('Y').'-'.$this->input->get('mnth').'-31';
            $sql.=" AND transaction_date between '$from_date' AND '$to_date' ";
        }

        if( !empty($client_group_id) ){
        	$query = " SELECT * FROM `fc_clients` WHERE client_id IN ( SELECT client_id FROM `fc_client_code` WHERE parent_id='$client_group_id' )";
        }

        if( !empty($client_id) ){
        	$query = " SELECT * FROM `fc_clients` WHERE client_id='$client_id' ";
        }

        $result_res = $this->db->query($query);
        $results = $result_res->result_array();
        
        foreach ($results as $result) {

        	$currency_arr = $this->currency_model->show($result['currency_id']);
			$account = $currency_arr['currency_code'];
			$client_currency_id = $result['currency_id'];
			$record = array();
        // txn list
        $query_1=$this->db->query(" SELECT * FROM `fc_transaction` where 
        	client_id=".$result['client_id']." ".$sql." order by transaction_id desc ");
		$txn_result_1=$query_1->result_array();

		foreach ($txn_result_1 as $txn_results) {
			
		$txn_type=($txn_results['txn_type']==1)?'<span class="badge badge-success">Credit</span>':'<span class="badge badge-danger">Debit</span>';
		$currency_arr = $this->currency_model->show($txn_results['currency_id']);
		$currency_name = $currency_arr['currency_code'];

		$fc_credit_c=$rm_credit_c=$fc_debit_c=$rm_debit_c=$fc_total_balance=$rm_total_balance=0;
		$stock_res01 = $this->db->query(" SELECT SUM(rm_total_rate) AS rm_total_rate,SUM(fc_total_rate) AS fc_total_rate,txn_type FROM `fc_transaction` where `transaction_id` <= ".$txn_results['transaction_id']." AND 
			client_id='".$txn_results['client_id']."' GROUP BY txn_type ");
		$stock_row01 = $stock_res01->result_array();
		foreach ($stock_row01 as $stock_value) {
			if($stock_value['txn_type'] == 1){
				$fc_credit_c += $stock_value['fc_total_rate'];
				$rm_credit_c += $stock_value['rm_total_rate'];
			}
			if($stock_value['txn_type'] == 2){
				$fc_debit_c += $stock_value['fc_total_rate'];
				$rm_debit_c += $stock_value['rm_total_rate'];
			}	
		}
				
		$fc_total_balance = $fc_debit_c-$fc_credit_c;
		$rm_total_balance = $rm_debit_c-$rm_credit_c;

		$credit_amt_1 = $debit_amt_1 = $remaining_bal = $fc_rm_rate = 0;
		if($client_currency_id == 1){
			if($txn_results['txn_type'] == 1){
				$credit_amt_1 = $txn_results['rm_total_rate'];
			}else{
				$debit_amt_1 = $txn_results['rm_total_rate'];
			}
			$remaining_bal = $rm_total_balance;
			$fc_rm_rate = $txn_results['rm_rate'];
		}else{
			if($txn_results['txn_type'] == 1){
				$credit_amt_1 = $txn_results['fc_total_rate'];
			}else{
				$debit_amt_1 = $txn_results['fc_total_rate'];
			}
			$remaining_bal = $fc_total_balance;
			$fc_rm_rate = $txn_results['fc_rate'];
		}


		$record[]=array(
				'transaction_reference' =>	'<span class="badge badge-default">'.$txn_results['transaction_reference'].'</span>',
				'transaction_date'		=>	date('d-M y',strtotime($txn_results['transaction_date'])),
				'txn_type'				=>	$txn_type,
				'currency_descr'		=>	$txn_results['currency_descr'],
				'currency_name'			=>	$currency_name,
				'quantity'				=>	number_format($txn_results['quantity'],2),
				'fc_rm_rate'			=>	number_format($fc_rm_rate,5),
				'credit_amt_1'			=>	number_format($credit_amt_1,2),
				'debit_amt_1'			=>	number_format($debit_amt_1,2),
				'remaining_bal'			=>	number_format($remaining_bal,2)
				);
				
			// find the opening balance
			$qsql = "";
			if( !empty($this->input->get('from_date')) && !empty($this->input->get('to_date')) ){
                $from_date = date('Y-m-d',strtotime(str_replace('/','-',$this->input->get('from_date'))));
    			$to_date = date('Y-m-d',strtotime(str_replace('/','-',$this->input->get('to_date'))));
    			$qsql.=" AND transaction_date between '$from_date' AND '$to_date' ";
            }
            if( !empty($this->input->get('currency_id')) ){
                $qsql .= " AND currency_id=".$this->input->get('currency_id');
            }
			
			$first_query=$this->db->query(" SELECT transaction_id FROM `fc_transaction` where client_id='".$txn_results['client_id']."' ".$qsql." order by transaction_id ASC LIMIT 1 ")->row_array();
			if($first_query['transaction_id'] == $txn_results['transaction_id']){
			    if($client_currency_id == 1){
			    $open_bal_q = $this->db->query(" select (sum(coalesce((case when (`txn_type` = '2') then `rm_total_rate` end),0)) - sum(coalesce((case when (`txn_type` = '1') then `rm_total_rate` end),0))) AS `balance` from `fc_transaction` WHERE client_id='".$txn_results['client_id']."' AND transaction_id <  ".$first_query['transaction_id'])->row_array();
			    }else {
			    $open_bal_q = $this->db->query(" select (sum(coalesce((case when (`txn_type` = '2') then `fc_total_rate` end),0)) - sum(coalesce((case when (`txn_type` = '1') then `fc_total_rate` end),0))) AS `balance` from `fc_transaction` WHERE client_id='".$txn_results['client_id']."' AND transaction_id <  ".$first_query['transaction_id'])->row_array();   
			    }
			    $record[] = [ 'transaction_reference' => '', 'transaction_date' => '', 'txn_type' => '', 'currency_descr' => '', 'currency_name' => '', 'quantity' => '', 
			    'fc_rm_rate' => '', 'credit_amt_1' => '' , 'debit_amt_1' => 'Prev Bal', 'remaining_bal' => number_format($open_bal_q['balance'],2)];
			}
		    
				
		}


        	$client_account = $this->common_model->client_account($result['client_id'],2);
        	$data['clients'][] = array(
        		'rm_balance'	=> $client_account['rm_balance'],
				'fc_balance'	=> $client_account['fc_balance'],
				'fc_convert'	=> $client_account['fc_convert'],
				'client_name'	=> $result['client_code'].' - '.$result['name'],
				'account'		=>	$account,
				'transactions'	=>	$record,
				'client_currency_id' => $result['currency_id']
        	);
        }

        $this->load->view('report/client_report_list',$data);
	}

	function settle_report_list(){
		extract($_REQUEST);
		$sql="";
		if( $this->session->userdata('fcadmin_type') != 1 ){
			//die('You dont have permission');
		}
		if( $this->input->get('filter_type') > 0 && $this->input->get('filter_type') < 3 ){
			$sql.=" AND flag = ".$this->input->get('filter_type'); 
		}
		if( !empty($this->input->get('from_date')) && !empty($this->input->get('to_date'))  ){
			$from_date = date('Y-m-d',strtotime(str_replace('/','-',$this->input->get('from_date'))));
			$to_date = date('Y-m-d',strtotime(str_replace('/','-',$this->input->get('to_date'))));
			$sql.=" AND closing_date between '$from_date' AND '$to_date' ";
		}

		if( $settlement_type == 1 ) {
			$query=$this->db->query(" SELECT * FROM `fc_settlement` where 1 ".$sql." order by settlement_id desc ");
		}

		$sql="";
		if( $this->input->get('filter_type') > 0 && $this->input->get('filter_type') < 3 ){
			$sql.=" AND flag = ".$this->input->get('filter_type'); 
		}
		if( !empty($this->input->get('from_date')) && !empty($this->input->get('to_date'))  ){

			$from_date = date('Y-m-d',strtotime(str_replace('/','-',$this->input->get('from_date'))));
			$to_date = date('Y-m-d',strtotime(str_replace('/','-',$this->input->get('to_date'))));
			$sql.=" AND YEAR(month_year)='".date('Y',strtotime($from_date))."' AND MONTH(month_year) BETWEEN '".date('m',strtotime($from_date))."' AND '".date('m',strtotime($to_date))."' ";
		}

		if( $settlement_type == 2 ) {
			$query=$this->db->query(" SELECT *, month_year AS closing_date,total_profit AS transaction_net_profit,total_profit AS order_net_profit,id AS settlement_id FROM `fc_settlement_month` where 1 ".$sql." order by id desc ");
		}

		$results=$query->result_array();
		$record['data']=array();

	foreach ($results as $result) {
		
		if( $settlement_type == 1 ) {
			$flag = " AND flag=2 ";
		}

		if( $settlement_type == 2 ) {
			$flag = " AND flag=3 ";
		}

		$txn_res = $this->db->query(" SELECT transaction_reference FROM `fc_transaction` WHERE settlement_id='".$result['settlement_id']."'  ".$flag);
		$txn_row = $txn_res->row_array();


		if($result['flag'] == 1) {
			$profit_amount = $result['transaction_net_profit'];
			$settle_type = '<span class="badge badge-primary">Txn</span>';
		}

		if($result['flag'] == 2) {
			$profit_amount = $result['order_net_profit'];
			$settle_type = '<span class="badge badge-success">Order</span>';
		}

		$record['data'][]=array(
				$txn_row['transaction_reference'],
				date('d-M y',strtotime($result['closing_date'])),
				'-',
				number_format($profit_amount,2),
				$settle_type
			);
	}
		echo json_encode($record);

	}

	function currency_report($client_id=0){

		$sql="";
		if( $this->session->userdata('fcadmin_type') != 1 ){
		//	$sql.=" AND user_id=".$this->session->userdata('fcuser_id');
		}
		if( $client_id > 0 ){
			$sql.=" AND client_id = ".$client_id; 
		}
		if( $this->input->get('currency_id') > 0 ){
			$sql.=" AND currency_id = ".$this->input->get('currency_id'); 
		}
		if( $this->input->get('filter_type') == 1 || $this->input->get('filter_type') == 2 ){
			$sql.=" AND txn_type='".$this->input->get('filter_type')."' ";
		}
		$view_type=$this->input->get('view_type');

		if( !empty($this->input->get('from_date')) && !empty($this->input->get('to_date'))  ){
			$from_date = date('Y-m-d',strtotime(str_replace('/','-',$this->input->get('from_date'))));
			$to_date = date('Y-m-d',strtotime(str_replace('/','-',$this->input->get('to_date'))));
			$sql.=" AND transaction_date between '$from_date' AND '$to_date' ";
		}
		$query=$this->db->query(" SELECT *, IF(txn_type=1,before_stock_credit_m+quantity,before_stock_credit_m) AS credit_qty, IF(txn_type=2,before_stock_debit_m+quantity,before_stock_debit_m) AS debit_qty FROM `fc_transaction` where 1 ".$sql." order by transaction_id desc ");
		$results=$query->result_array();

		$record['data']=array();
		$sno=0;

		foreach ($results as $result) {

			$txn_type=($result['txn_type']==1)?'<span class="badge badge-success">Credit</span>':'<span class="badge badge-danger">Debit</span>';
			$currency_arr = $this->currency_model->show($result['currency_id']);
			$currency_name = $currency_arr['currency_code'];

			$client=$this->client_model->show($result['client_id']);
			$client_code=$client['client_code'];

			// $stock_res01 = $this->db->query(" SELECT SUM(quantity) AS qty,txn_type FROM `fc_transaction` where `transaction_id` <= ".$result['transaction_id']."  AND currency_id=".$result['currency_id']." AND txn_order=0 AND flag IN (0,1) GROUP BY txn_type ");
	
			// $stock_row01 = $stock_res01->result_array();
			// $credit_stock=$debit_stock=0;
			// foreach ($stock_row01 as $stock_value) {				
			// 	if($stock_value['txn_type'] == 1){
			// 		$credit_stock = $stock_value['qty'];
			// 	}
			// 	if($stock_value['txn_type'] == 2){
			// 		$debit_stock = $stock_value['qty'];
			// 	}				
			// }
			// $stock = $credit_stock-$debit_stock;

			$credit_stock = $result['credit_qty'];
			$debit_stock  = $result['debit_qty'];
			$stock = $credit_stock-$debit_stock;
			
			$record['data'][]=array(
					'<span class="badge badge-default">'.$result['transaction_reference'].'</span>',
					date('d-M y',strtotime($result['transaction_date'])),
					$txn_type,
					$result['currency_descr'],
					$currency_name,
					$client_code,
					number_format($result['quantity'],2),
					number_format($result['fc_rate'],5),
					number_format($result['fc_total_rate'],2),
					number_format($result['rm_rate'],5),
					number_format($result['rm_total_rate'],2),
					// number_format($credit_stock,2),
					// number_format($debit_stock,2),
					// number_format($stock,2)
			);
		}
		echo json_encode($record);
	}

	public function closing_stock()
	{
		if( $this->session->userdata('fcadmin_type') != 1 ){
			//die('You dont have permission');
		}
		$data['page_title'] = "Stock Report";
		$data['user_access']=$this->session->userdata('user_access');
		$client_q = $this->db->query(" SELECT client_id,client_group,client_code,stock_update_date, name FROM `fc_clients` ORDER BY client_group ASC, client_code ASC ");
		$client_r = $client_q->result_array();
		$data['clients'] = [];
		foreach ($client_r as $client) {

			$account = $this->db->get_where('fc_client_account', ['client_id' => $client['client_id']])->row_array();
			$fc_credit=$fc_debit=$rm_credit=$rm_debit=0;
			$fc_bal = $account['fc_debit'] - $account['fc_credit'];
			if($fc_bal>0){ $fc_debit = $fc_bal; }else{ $fc_credit = abs($fc_bal);  }
			$rm_bal = $account['rm_debit'] - $account['rm_credit'];
			if($rm_bal>0){ $rm_debit = $rm_bal; }else{ $rm_credit = abs($rm_bal); }

			$data['clients'][] = [
				'open_date'		=> ($client['stock_update_date']!='0000-00-00' && $client['stock_update_date'] != NULL)?date('d-M Y',strtotime($client['stock_update_date'])):'-',
				'client_id' 	=> $client['client_id'],
				'client_name'	=> $client['name'],
				'client_code'	=> $client['client_code'],
				'stock_credit'	=> $fc_credit,
				'stock_debit'	=> $fc_debit,
				'rm_credit'		=> $rm_credit,
				'rm_debit'		=> $rm_debit
			];
		}
		$currency_q = $this->db->query("SELECT * FROM `fc_currency` where (stock_credit-stock_debit) > 0 OR (stock_credit-stock_debit) < 0 ");
		$currencies = $currency_q->result_array();
		$data['currencies'] = [];
		foreach ($currencies as $currency) {

			$balance_stock = ($currency['stock_credit']-$currency['stock_debit']);
			$balance_rm = ($balance_stock*$currency['currency_avg_rate'])/$currency['rate_unit'];
			$stock_credit = $stock_debit = $credit_rm_1 = $debit_rm_1 = 0;
			if($balance_stock > 0){
				$stock_debit = $balance_stock;
				$debit_rm_1 = $balance_rm;
			}
			if($balance_stock < 0){
				$stock_credit = $balance_stock;
				$credit_rm_1 = $balance_rm;
			}

			$data['currencies'][] = [
				'currency_id' 	=> $currency['currency_id'],
				'currency_code'	=> $currency['currency_code'],
				'stock_credit'	=> abs($stock_credit),
				'stock_debit'	=> abs($stock_debit),
				'rm_credit'		=> abs($credit_rm_1),
				'rm_debit'		=> abs($debit_rm_1),
			];
		}

		$data['tab'] = (!empty($this->input->get('tab')))?$this->input->get('tab'):'';
		$current_real_credit = $current_real_debit = 0;
		$today_profit = $this->today_profit();
		$data['current_real_credit'] = ($today_profit > 0)?$today_profit:0;
		$data['current_real_debit'] = ($today_profit < 0)?$today_profit:0;
		$data['clients_group'] = $this->client_model->clientsListByGroup('EXPN');
		$this->load->view('report/careport', $data);
	}
	
	function today_profit(){

		$this->load->model(array("common_model","currency_model"));
		$sql="";
		if( !$this->common_model->verify_user() ){
			//$sql.=" AND user_id=".$this->session->userdata('fcuser_id')."  ";
		}
		$txn_date = date('Y-m-d');
		//$sql  	.=" AND transaction_date='".$txn_date."' ";
		$total_profit = 0;
		$query=$this->db->query(" SELECT * FROM `fc_transaction` where currency_id!=1 AND txn_type=2 AND flag=0 ".$sql." order by transaction_id desc ");
		$results = $query->result_array();

		foreach ($results as $result) {

			$currency_arr = $this->currency_model->show($result['currency_id']);
            //$rate_unit = ($currency_arr['rate_unit']>0)?$currency_arr['rate_unit']:1;
            $rate_unit = ($result['currency_rate_unit']>0)?$result['currency_rate_unit']:1;
			$rqty = $result['quantity']/$rate_unit;

			$currency_avg_rate = $result['stock_margin_value_1'];
			if( $result['is_first_debit'] == 1 ){

				$first_credit_res = $this->db->query(" SELECT transaction_id FROM `fc_transaction` WHERE 
					txn_group='".$result['txn_group']."' AND currency_id='".$result['currency_id']."'
					AND txn_type=1  ");

				if( $first_credit_res->num_rows() == 0 ) {
					$currency_avg_rate = '0.0000000000'; // average rate should be zero if no equivalent credit available
				}
			}

	        if($currency_avg_rate > 0){
	        	$profit= ($rqty*$result['rm_rate'])-($rqty*$currency_avg_rate);
	        }else{
	           	$profit=0; 
	        }
	        $total_profit += $profit;
		}

		return $total_profit;
	}

	public function closing_stock_ajax()
	{
		$data['data'] = [];
		$sql = "";
		if(!empty($this->input->get('from_date'))){
			$sql = " AND closing_date = '".date('Y-m-d',strtotime( str_replace('/','-',$this->input->get('from_date')) ))."' ";
		}else{
			$sql = " AND closing_date = '".date('Y-m-d')."' ";
		}
		$sno = 0;
		$query = $this->db->query(" SELECT * FROM `fc_closing_stock` WHERE (stock_credit-stock_debit)>0 ".$sql." GROUP BY currency_id ORDER BY id DESC ");
		$results = $query->result_array();
		foreach ($results as $result) {
			$currency = $this->currency_model->show($result['currency_id']);
			$data['data'][] = array(
				++$sno,
				$currency['currency_code']. '-' .$currency['description'],
				//number_format($result['stock_credit'],2),
				//number_format($result['stock_debit'],2),
				number_format(($result['stock_credit']-$result['stock_debit']),2),
				//number_format($result['credit_rm'],2),
				//number_format($result['debit_rm'],2),
				number_format($result['avg_rate'],5),
				number_format(($result['credit_rm']-$result['debit_rm']),2),
			);
		}

		echo json_encode($data);
	}

	function deleted_list()
	{
		$sql="";
		if( !$this->common_model->verify_user() ){
		//	$sql.=" AND user_id=".$this->session->userdata('fcuser_id')."  ";
		}
		if( $this->input->get('ftxn_type') ){
			$sql.=" AND txn_type='".$this->input->get('ftxn_type')."' ";
		}
		if( $this->input->get('ftxn_id') ){
			$sql.=" AND transaction_id='".$this->input->get('ftxn_id')."' ";
		}
		if( $this->input->get('fgrp_id') ){
			$sql.=" AND client_id IN ( SELECT client_id FROM `fc_client_code` WHERE parent_id='".$this->input->get('fgrp_id')."') "; 
		}
		if( $this->input->get('fcust_id') ){
			$sql.=" AND client_id='".$this->input->get('fcust_id')."' "; 
		}
		if( $this->input->get('fcur_id') ){
			$sql.=" AND currency_id='".$this->input->get('fcur_id')."' "; 
		}
		if( $this->input->get('ftxn_date') ){
			$fdate = str_replace('/','-',$this->input->get('ftxn_date'));
			$txn_date = date('Y-m-d',strtotime($fdate));
			$sql.=" AND transaction_date='".$txn_date."' "; 
		}
		if( !$this->input->get('foption') ){
			
			$sql.=" AND flag='0' AND transaction_date='".date('Y-m-d')."' AND user_id='".$this->session->userdata('fcuser_id')."' "; 
		}else{
			if( $this->session->userdata('fcadmin_type') != 1 ){
			//	$sql.=" AND user_id='".$this->session->userdata('fcuser_id')."' ";
			}
		}

		$query = $this->db->query("SELECT * FROM `fc_deleted_transaction` WHERE 1 ".$sql." ORDER BY id DESC");
		$results = $query->result_array();
		$record['data']=array();
		$sno=0;
		foreach ($results as $result) {

			$txn_type=($result['txn_type']==1)?'<span class="badge badge-success">Credit</span>':'<span class="badge badge-danger">Debit</span>';

			$currency_arr = $this->currency_model->show($result['currency_id']);
			$currency_name = $currency_arr['currency_code'];

			$client_arr = $this->client_model->show($result['client_id']);
			$client_code = $client_arr['client_code'];
			$client_group = $client_arr['client_group'];

			$record['data'][]=array(
					'<span class="badge badge-default">'.$result['transaction_reference'].'</span>',
					date('d-M y',strtotime($result['transaction_date'])),
					$txn_type,
					$client_group,
					$client_code,
					$result['currency_descr'],
					$currency_name,
					number_format($result['quantity'],2),
					number_format($result['fc_rate'],5),
					number_format($result['fc_total_rate'],2),
					number_format($result['rm_rate'],5),
					number_format($result['rm_total_rate'],2),
			);
		}
		echo json_encode($record);
	}

	// START EXPENSE	

	function expense_list_ajax()
	{
		if( $this->session->userdata('fcadmin_type') != 1 ){
			//die('You dont have permission');
		}
		$sql="";
		$allow_data = false;
		if( !$this->common_model->verify_user() ){
		//	$sql.=" AND user_id=".$this->session->userdata('fcuser_id')."  ";
		}
		if( !empty($this->input->get('from_date')) && !empty($this->input->get('to_date')) ){
			$from_date  = date('Y-m-d',strtotime(str_replace('/','-',$this->input->get('from_date'))));
			$to_date 	= date('Y-m-d',strtotime(str_replace('/','-',$this->input->get('to_date'))));
			$sql.=" AND transaction_date BETWEEN '".$from_date."' AND '".$to_date."' "; 
			$allow_data = true;
		}
		if(!empty($this->input->get('client_id')))
		{
			$sql .= " AND client_id='".$this->input->get('client_id')."' ";
		} else {
			$sql .= " AND client_id IN (SELECT client_id FROM `fc_clients` where client_group='EXPN') ";
		}

		$record['data']=array();
		if($allow_data){

			$query = $this->db->query(" SELECT * FROM `fc_transaction` WHERE 1 ".$sql." ORDER BY transaction_id DESC  ");
			$results = $query->result_array();
			$sno=0;
			foreach ($results as $result) {

				$txn_type=($result['txn_type']==1)?'<span class="badge badge-success">Credit</span>':'<span class="badge badge-danger">Debit</span>';

				$currency_arr = $this->currency_model->show($result['currency_id']);
				$currency_name = $currency_arr['currency_code'];

				$client_arr = $this->client_model->show($result['client_id']);
				$client_code = $client_arr['client_code'];

				$record['data'][]=array(
						'<span class="badge badge-default">'.$result['transaction_reference'].'</span>',
						date('d-M y',strtotime($result['transaction_date'])),
						$txn_type,
						$client_code,
						'',
						$result['currency_descr'],
						$currency_name,
						number_format($result['fc_rate'],5),
						number_format($result['fc_total_rate'],2),
						number_format($result['rm_rate'],5),
						number_format($result['rm_total_rate'],2),
				);
			}
		}
		echo json_encode($record);
	}
	// END EXPENSE

	// EMPLOYEE REPORT
	public function employee_balance_ajax()
	{
		$this->load->model(['payroll/loan_model','payroll/advance_model']);
		$record['data']=array();
		$query = $this->db->query(" SELECT * FROM `fc_employee` ORDER BY employee_name ASC ");
			$results = $query->result_array();
			$sno=0;
			foreach ($results as $result) {

				$loan_data = $this->db->get_where('fc_loan', ['employee_id' => $result['employee_id']]);
				$numberOfLoan = $loan_data->num_rows();

				$loan_account = $this->loan_model->advance_account($result['employee_id']);
				$loan_balance = $loan_account['balance_amount'];

				$pending_month = $this->db->query("SELECT A.loan_id FROM `fc_loan` A LEFT JOIN `fc_loan_terms` B ON A.loan_id=B.loan_id WHERE B.payment_status=0 AND A.employee_id='".$result['employee_id']."' ");
				$pending_month = $pending_month->num_rows();

				$advance_acc = $this->advance_model->advance_account($result['employee_id']);
				$advance_bal = $advance_acc['balance_amount'];

				$basic_acc = $this->db->query("SELECT (SELECT basic_pay FROM fc_salary WHERE employee_id='".$result['employee_id']."' AND status=1 AND txn_status=1 ORDER BY salary_id DESC LIMIT 1 ) AS basic_pay ,sum(net_salary) AS net_salary FROM `fc_salary` WHERE employee_id='".$result['employee_id']."' AND status=1 AND txn_status=1 ");
				$basic_acc_res = $basic_acc->row_array();
				if($basic_acc->num_rows()){
					$basic_salary = $basic_acc_res['basic_pay'];
					$salary_paid  = $basic_acc_res['net_salary'];
				}else{
					$basic_salary = $salary_paid = 0;
				}

				$emi_res = $this->db->query(" SELECT amout_per_month FROM `fc_loan` A LEFT JOIN `fc_loan_terms` B ON A.loan_id=B.loan_id WHERE B.payment_status=0 AND A.employee_id='".$result['employee_id']."' ORDER BY A.loan_id DESC LIMIT 1  ");
				$emi_row = $emi_res->row_array();
				if($emi_res->num_rows() == 0){
					$emi_month = number_format($emi_row['amout_per_month'],2);
				}else{
					$emi_month = '-';
				}

				$record['data'][]=array(
						'<span class="badge badge-default">'.$result['employee_code'].'</span>',
						$result['employee_name'],
						$numberOfLoan,
						number_format($loan_balance,2),
						$pending_month,
					//	$emi_month,
						number_format($advance_bal,2),
						number_format($basic_salary,2),
						number_format($salary_paid,2)
				);
			}

			echo json_encode($record);
	}
	// END EMPLOYEE REPORT

	// OPEN BAL
	public function opening_balance()
	{
		$query = $this->db->query(" SELECT client_group, client_code, fc_balance, current_balance, current_balance_type, currency_id,stock_update_date FROM `fc_clients` WHERE stock_update_flag=1 AND (fc_balance > 0 OR current_balance > 0) ORDER BY client_group ");	
		$data = [];
		$data['results'] = $data['total'] = [];
		$results = $query->result_array();
		$total_credit = $total_debit = 0;
		$data['total'] = ['total_credit' =>0, 'total_debit' =>0, 'balance' =>0];
		foreach ($results as $result) {
			$currency_id = $result['currency_id'];
			$currency_arr = $this->currency_model->show($result['currency_id']);
			$currency_name = $currency_arr['currency_code'];
			$fc_credit=$fc_debit=$rm_credit=$rm_debit=0;
			if($result['current_balance_type'] == 1 && $currency_id == 1){
				$fc_credit = 0;
				$rm_credit = $result['current_balance'];
			}
			if($result['current_balance_type'] == 2 && $currency_id == 1){
				$fc_debit = 0;
				$rm_debit = $result['current_balance'];
			}
			if($result['current_balance_type'] == 1 && $currency_id != 1){
				$rm_credit = $result['current_balance'];
				$fc_credit = $result['fc_balance'];
			}
			if($result['current_balance_type'] == 2 && $currency_id != 1){
				$rm_debit = $result['current_balance'];
				$fc_debit = $result['fc_balance'];
			}
			$total_credit += $rm_credit;
			$total_debit  += $rm_debit;
			$data['results'][] = [
				'open_date'		=> ($result['stock_update_date']!='0000-00-00' && $result['stock_update_date'] != NULL)?date('d-M Y',strtotime($result['stock_update_date'])):'-',
				'client_group' 	=> $result['client_group'],
				'client_code' 	=> $result['client_code'],
				'currency_name' => $currency_name,
				'fc_credit'		=> number_format($fc_credit,2),
				'fc_debit'		=> number_format($fc_debit,2),
				'rm_credit'		=> number_format($rm_credit,2),
				'rm_debit'		=> number_format($rm_debit,2),

			];
		}	
		$data['total'] = ['total_credit' => number_format($total_credit,2), 'total_debit' => number_format($total_debit,2), 'balance' => number_format( ($total_credit-$total_debit),2)];

		echo json_encode($data);
	}
	// END OPEN BAL

	// SETTLEMENT
	function settlement_list_ajax()
	{
		$sql="";
		$allow_data = false;
		if( !empty($this->input->get('from_date')) ){
			$from_date  = date('Y-m-d',strtotime(str_replace('/','-',$this->input->get('from_date'))));
			$sql.=" AND A.closing_date='".$from_date."' "; 
			$allow_data = true;
		}

		$record['data']=array();
		if($allow_data){

			$query = $this->db->query(" SELECT * FROM `fc_settlement` A LEFT JOIN `fc_settlement_mtxn` B ON A.settlement_id=B.settlement_id WHERE 1 ".$sql." ORDER BY B.transaction_id DESC ");
			$results = $query->result_array();
			$sno=0;
			foreach ($results as $result) {

				$transaction = $this->db->get_where('fc_transaction', ['transaction_id' => $result['transaction_id']])->row_array();
				$txn_type=($transaction['txn_type']==1)?'<span class="badge badge-success">Credit</span>':'<span class="badge badge-danger">Debit</span>';

				$currency_arr = $this->currency_model->show($transaction['currency_id']);
				$currency_name = $currency_arr['currency_code'];

				$client_arr = $this->client_model->show($transaction['client_id']);
				$client_code = $client_arr['client_code'];

				$net_profit = $result['profit_amount'];

				$record['data'][]=array(
						'<span class="badge badge-default">'.$transaction['transaction_reference'].'</span>',
						date('d-M y',strtotime($transaction['transaction_date'])),
						$txn_type,
						$client_code,
						$currency_name,
						number_format($transaction['quantity'],2),
						number_format($transaction['fc_convert'],5),
						number_format($transaction['rm_total_rate'],2),
						number_format($transaction['stock_margin_value_1'],5),
						number_format($net_profit,2)
				);
			}
		}
		echo json_encode($record);
	}
	// END SETTLEMENT
}
?>