<?php
defined('BASEPATH') OR exit('No direct script access allowed');
class Settlement extends MY_Controller
{
	function __construct(){
		parent::__construct();
		$this->load->model(array('client_model','common_model','currency_model','settlement_model'));
		$this->load->helper('sequency');
	}

	function index(){
		$data['page_title']='Settlement';
		$data['message'] = '';
		$csrf = array(
		        'name' => $this->security->get_csrf_token_name(),
		        'hash' => $this->security->get_csrf_hash()
		);
		$data['csrf']=$csrf;
		$data['user_access']=$this->session->userdata('user_access');
		
		$data['txn_filter_date_c'] = date('d/m/Y');
		$data['txn_filter_date_mom'] = date('m/Y');
		
		/* Daily Settlement Form submission */
		if($this->input->server('REQUEST_METHOD')=='POST' && $this->input->post('form_type') == 'daily' && !empty($_POST) ){

			if( $this->permission->entry_access(5,$this->session->userdata('fcuser_id')) ){
				$result=$this->settlement_model->insert();
				if( isset($result['success']) ){
                    $data['txn_filter_date_c'] = isset($_POST['ctxn_date'])?$_POST['ctxn_date']:date('d/m/Y');
					//$data['message']=$this->alert->success($result['success']);
					unset($_POST);
				
				}elseif( isset($result['danger']) ){

					$data['message']=$this->alert->warning($result['danger']);
				}
			}else{
					$data['message']=$this->alert->warning('Permission Denied !!!');
			}

		}
		/*Daily Settlement END Form sub*/

		/* Monthly settlement form */

		if($this->input->server('REQUEST_METHOD')=='POST' && $this->input->post('form_type') == 'month' && !empty($_POST) ){

			if( $this->permission->entry_access(5,$this->session->userdata('fcuser_id')) ){
				$result=$this->settlement_model->month_insert();
				if( isset($result['success']) ){
					//$data['message']=$this->alert->success($result['success']);
					$data['txn_filter_date_mom'] = isset($_POST['ctxn_date'])?$_POST['ctxn_date']:date('m/Y');
					unset($_POST);
				}elseif( isset($result['danger']) ){
					$data['message']=$this->alert->warning($result['danger']);
				}
			}else{
					$data['message']=$this->alert->warning('Permission Denied !!!');
			}

		}

		/* END Monthly settlement form */

		/* Yearly profit */
		$expense_clients=$this->settlement_model->expense_clients();
		foreach ($expense_clients as $client_res) {
			$client_account = $this->settlement_model->client_account($client_res['client_id']);
			$expense_amount = $client_account['rm_debit']-$client_account['rm_credit'];
			$data['yearly_expense_lists'][]=array(
				'client_id'		=>	$client_res['client_id'],
				'client_group'	=>	$client_res['client_group'],
				'client_code'	=>	$client_res['client_code'],
				'client_name'	=>	$client_res['name'],
				'expense_amount'=>	$expense_amount
			);
		}
		
		/**
		 * Check transaction and order filter date exist in cookie If not update current date 
		**/
		//$data['txn_filter_date_c'] = isset($_COOKIE['txn_filter_date_c'])?$_COOKIE['txn_filter_date_c']:date('d/m/Y');
		
		
		$this->load->view('settlement',$data);
	}

	function show_expense_list(){
		$data=array();
		$month_date=$this->input->post('month_date');
		$month_date_1=explode('/',$month_date);
		$ExpData=array(
						'month'	=>	$month_date_1[0],
						'year'	=>	$month_date_1[1],
						'flag'	=>	1	
					  );
		$data['month_main_txn']=$this->expense_list($ExpData);

		$ExpData=array(
						'month'	=>	$month_date_1[0],
						'year'	=>	$month_date_1[1],
						'flag'	=>	2	
					  );
		$total_exp_arr = $this->settlement_model->total_expense_amount($ExpData);
		$data['total_expense_amount'] = $total_exp_arr['total_expense_amount'];
		
		//Check expense amount for old records
		$exp_query = $this->db->query(" SELECT total_expense_amount FROM `fc_settlement_month` WHERE month(month_year)='".$month_date_1[0]."' AND year(month_year)='".$month_date_1[1]."' AND flag=1 ");
		$exp_query_r = $exp_query->row_array();
		if($exp_query->num_rows() > 0) {
		  //  $data['total_expense_amount'] = $exp_query_r['total_expense_amount'];
		}
		$data['month_order_txn']=$this->expense_list($ExpData);

		$data['month_date'] = date('Y-m-t',strtotime(str_replace('/','-','01/'.$month_date)));
		$this->load->view('ajax/settlement_month',$data);
	}

	function expense_list($ExpData){
		$data=array();
		$expenses=$this->settlement_model->month_txn($ExpData);
		return $expenses;
	}



	function getlist(){
		$this->load->model("common_model");
		$sql="";
		if( !$this->common_model->verify_user() ){
			$sql.=" AND user_id=".$this->session->userdata('fcuser_id')."  ";
		}
		
		/**
		 * Update filter date in cookie
		 * 
		 * */
		setcookie('txn_filter_date_c', $this->input->get('fdate'), time() + (86400 * 30), "/");
		
		$fdate = str_replace('/','-',$this->input->get('fdate'));
		$txn_date = date('Y-m-d',strtotime($fdate));
		$sql.=" AND transaction_date='".$txn_date."' ";
		$data['allow_main_eod'] = 1; // if 1 allow
		$data['allow_order_eod'] = 1; // if 1 allow

		$allowm_query = $this->db->query(" SELECT settlement_id FROM `fc_settlement` WHERE flag=1 AND closing_date='$txn_date'  ");
		if($allowm_query->num_rows() > 0){
			$data['allow_main_eod'] = 0; // if 0 dont allow
		}

		$allowo_query = $this->db->query(" SELECT settlement_id FROM `fc_settlement` WHERE flag=2 AND closing_date='$txn_date'  ");
		if($allowo_query->num_rows() > 0){
			$data['allow_order_eod'] = 0;  // if 0 dont allow
		}

		$results=$this->settlement_model->record_list($sql);
		$record=array();
		$record['con'] = $this->input->get('con');
		$record['main']=array();
		$record['order_main']=array();
		$sno=0;
		foreach ($results as $result) {

			$txn_type=($result['txn_type']==1)?'<span class="badge badge-success">Credit</span>':'<span class="badge badge-danger">Debit</span>';

			$currency_arr = $this->currency_model->show($result['currency_id']);
			$currency_name = $currency_arr['currency_code'];
            $rate_unit = ($currency_arr['rate_unit']>0)?$currency_arr['rate_unit']:1;
			$client_arr = $this->client_model->show($result['client_id']);
			$client_code = $client_arr['name'].'-'.$client_arr['client_code'];
			$client_group = $client_arr['client_group'];
			$equivalent_credit_avail=0;
			$rqty = $result['quantity']/$rate_unit;
			$rm_rate_for_avg = $result['rm_rate'];

	$currency_avg_rate = $result['stock_margin_value_1'];
	$equivalent_credit_avail=1;
	if( $result['is_first_debit'] == 1 ){
		/* check there is credit record after first debit */
		// $first_credit_res = $this->db->query(" SELECT transaction_id,stock_margin_value_1 FROM `fc_transaction` WHERE transaction_id > '".$result['transaction_id']."' AND txn_type=1 AND currency_id='".$result['currency_id']."' AND txn_order=0 ORDER BY `transaction_id` ASC LIMIT 1 ");

		$first_credit_res = $this->db->query(" SELECT transaction_id FROM `fc_transaction` WHERE txn_group='".$result['txn_group']."' AND currency_id='".$result['currency_id']."' AND txn_type=1  ");

		if( $first_credit_res->num_rows() == 0 ) {
			$equivalent_credit_avail=0;
			$currency_avg_rate = '0.0000000000'; // average rate should be zero if no equivalent credit available
		}
	}

	        if($currency_avg_rate > 0){
	        	$profit= ($rqty*$rm_rate_for_avg)-($rqty*$currency_avg_rate);
	        }else{
	           	$profit=0; 
	        }	

        	if( $result['order_id'] == 0 && $result['currency_id'] != 17 ){ // main record enter by superadmin

				$record['main'][]=array(
					'ref'				=> '<span class="badge badge-default">'.$result['transaction_reference'].'</span>',
					'tdate'				=> date('d-M y',strtotime($result['transaction_date'])),
					'txn_type'			=> $txn_type,
					'client_code'		=> $client_code,
					'currency_name'		=> $currency_name,
					'quantity'			=> number_format($result['quantity'],2),
					'fc_convert'		=> number_format(round($rm_rate_for_avg,5),5),
					'fc_total_rate' 	=> number_format($result['rm_total_rate'],2),
					'rmout'				=> '',
					'system_convert'	=> $result['stock_margin_value'],
					'currency_avg_rate'	=> number_format(round($currency_avg_rate,5),5),
					'profit'			=> number_format($profit,2),
					'profit_hidden'		=> str_replace(",","",number_format($profit,10)),
					'transaction_id'	=> $result['transaction_id'],
					'client_id'			=> $result['client_id'],
					'equivalent_credit_avail' => $equivalent_credit_avail
				);
			}

			if( $result['order_id'] > 0 || $result['currency_id'] == 17 ){ // if the txn from order

        	$Orderprofit= ($rqty*$rm_rate_for_avg)-($rqty*$result['stock_margin_value_1']);
        

				$record['order_main'][]=array(
					'ref'				=> '<span class="badge badge-default">'.$result['transaction_reference'].'</span>',
					'tdate'				=> date('d-M y',strtotime($result['transaction_date'])),
					'txn_type'			=> $txn_type,
					'client_code'		=> $client_code,
					'currency_name'		=> $currency_name,
					'quantity'			=> number_format($result['quantity'],2),
					'fc_convert'		=> number_format(round($rm_rate_for_avg,5),5),
					'fc_total_rate' 	=> number_format($result['rm_total_rate'],2),
					'rmout'				=> '',
					'system_convert'	=> number_format(round($result['stock_margin_value'],5),5),
					'currency_avg_rate'	=> number_format(round($result['stock_margin_value_1'],5),5),
					'profit'			=> number_format($Orderprofit,2),
					'profit_hidden'		=> str_replace(",","",number_format($Orderprofit,10)),
					'transaction_id'	=> $result['transaction_id'],
					'client_id'			=> $result['client_id']
				);

			}

		}

		$record['deleted'] = array();
		$query = $this->db->query(" SELECT * FROM `fc_transaction_settlement` where currency_id NOT IN (1,54) AND flag=0 AND date(deleted_date)='".$txn_date."' ");
		$results = $query->result_array();

		foreach ($results as $result) {

			$txn_type=($result['txn_type']==1)?'<span class="badge badge-success">Credit</span>':'<span class="badge badge-danger">Debit</span>';

			$currency_arr = $this->currency_model->show($result['currency_id']);
			$currency_name = $currency_arr['currency_code'];
			$rate_unit = ($currency_arr['rate_unit']>0)?$currency_arr['rate_unit']:1;

			$client_arr = $this->client_model->show($result['client_id']);
			$client_code = $client_arr['name'].'-'.$client_arr['client_code'];
			$client_group = $client_arr['client_group'];
			
			$rqty = $result['quantity']/$rate_unit;

        if($result['currency_avg_rate']>0){
        	$profit= ($rqty*$result['rm_rate'] )-($rqty*$result['currency_avg_rate']);
        }else{
           $profit=0; 
        }

        if( $result['order_id'] == 0 && $result['currency_id'] != 17 ){

			$record['deleted'][]=array(
				'ref'				=> '<span class="badge badge-danger">'.$result['transaction_reference'].'</span>',
				'tdate'				=> date('d-M y',strtotime($result['transaction_date'])),
				'txn_type'			=> $txn_type,
				'client_code'		=> $client_code,
				'currency_name'		=> $currency_name,
				'quantity'			=> number_format($result['quantity'],2),
				'fc_convert'		=> number_format(round($result['rm_rate'],5),5),
				'fc_total_rate' 	=> number_format($result['rm_total_rate'],2),
				'rmout'				=> '',
				'system_convert'	=> number_format(round($result['stock_margin_value'],5),5),
				'currency_avg_rate'	=> number_format(round($result['currency_avg_rate'],5),5),
				'profit'			=> number_format($profit,2),
				'profit_hidden'		=> str_replace(",","",number_format($profit,10)),
				'transaction_id'	=> $result['transaction_id'],
				'client_id'			=> $result['client_id']
			);

		}

		if( $result['order_id'] > 0 || $result['currency_id'] == 17 ){

			$record['order_deleted'][]=array(
				'ref'				=> '<span class="badge badge-danger">'.$result['transaction_reference'].'</span>',
				'tdate'				=> date('d-M y',strtotime($result['transaction_date'])),
				'txn_type'			=> $txn_type,
				'client_code'		=> $client_code,
				'currency_name'		=> $currency_name,
				'quantity'			=> number_format($result['quantity'],2),
				'fc_convert'		=> number_format(round($result['rm_rate'],5),5),
				'fc_total_rate' 	=> number_format($result['rm_total_rate'],2),
				'rmout'				=> '',
				'system_convert'	=> $result['stock_margin_value'],
				'currency_avg_rate'	=> number_format(round($result['currency_avg_rate'],5),5),
				'profit'			=> number_format($profit,2),
				'profit_hidden'		=> str_replace(",","",number_format($profit,10)),
				'transaction_id'	=> $result['transaction_id'],
				'client_id'			=> $result['client_id']
			);
			
		}


		}

		//return $record;
		$data['results']=$record;
		$data['transaction_date'] = $txn_date;
		$this->load->view('ajax/settlement_data',$data);
	}


	function client_info($client_id){
		$data = array();
		$record=$this->client_model->show($client_id);
		$data['result']=$record;
		$currency_arr = $this->currency_model->show($record['currency_id']);
		$data['currency_name'] = $currency_arr['currency_code'];
		echo json_encode($data);
	}

	function dummy(){
		echo $this->settlement_model->dummy();
	}
}
?>