<?php
defined('BASEPATH') OR exit('No direct script access allowed');
class Settlement extends MY_Controller
{
	function __construct(){
		parent::__construct();
		$this->load->model(array('client_model','common_model','currency_model','settlement_model'));
		$this->load->helper('sequency');
	}

	function index(){
		$data['page_title']='Settlement';
		$data['message'] = '';
		$csrf = array(
		        'name' => $this->security->get_csrf_token_name(),
		        'hash' => $this->security->get_csrf_hash()
		);
		$data['csrf']=$csrf;
		$data['user_access']=$this->session->userdata('user_access');
		
		/* Daily Settlement Form submission */
		if($this->input->server('REQUEST_METHOD')=='POST' && $this->input->post('form_type') == 'daily' ){

			if( $this->permission->entry_access(5,$this->session->userdata('fcuser_id')) ){
				$result=$this->settlement_model->insert();
				if( isset($result['success']) ){

					$data['message']=$this->alert->success($result['success']);
				
				}elseif( isset($result['danger']) ){

					$data['message']=$this->alert->warning($result['danger']);
				}
			}else{
					$data['message']=$this->alert->warning('Permission Denied !!!');
			}

		}
		/*Daily Settlement END Form sub*/

		/* Monthly settlement form */

		if($this->input->server('REQUEST_METHOD')=='POST' && $this->input->post('form_type') == 'month' ){

			if( $this->permission->entry_access(5,$this->session->userdata('fcuser_id')) ){
				$result=$this->settlement_model->month_insert();
				if( isset($result['success']) ){
					$data['message']=$this->alert->success($result['success']);
				}elseif( isset($result['danger']) ){
					$data['message']=$this->alert->warning($result['danger']);
				}
			}else{
					$data['message']=$this->alert->warning('Permission Denied !!!');
			}

		}

		/* END Monthly settlement form */

		/* Yearly profit */
		$expense_clients=$this->settlement_model->expense_clients();
		foreach ($expense_clients as $client_res) {
			$client_account = $this->settlement_model->client_account($client_res['client_id']);
			$expense_amount = $client_account['rm_credit'] - $client_account['rm_debit'];
			$data['yearly_expense_lists'][]=array(
				'client_id'		=>	$client_res['client_id'],
				'client_group'	=>	$client_res['client_group'],
				'client_code'	=>	$client_res['client_code'],
				'client_name'	=>	$client_res['name'],
				'expense_amount'=>	$expense_amount
			);
		}
		

		$this->load->view('settlement',$data);
	}

	function show_expense_list(){
		$data=array();
		$month_date=$this->input->post('month_date');
		$month_date_1=explode('/',$month_date);
		$ExpData=array(
						'month'	=>	$month_date_1[0],
						'year'	=>	$month_date_1[1],
						'flag'	=>	1	
					  );
		$data['month_main_txn']=$this->expense_list($ExpData);

		$ExpData=array(
						'month'	=>	$month_date_1[0],
						'year'	=>	$month_date_1[1],
						'flag'	=>	2	
					  );
		 $total_exp_arr = $this->settlement_model->total_expense_amount($ExpData);
		 $data['total_expense_amount'] = $total_exp_arr['total_expense_amount'];
		$data['month_order_txn']=$this->expense_list($ExpData);

		$data['month_date'] = date('Y-m-t',strtotime(str_replace('/','-','01/'.$month_date)));
		$this->load->view('ajax/settlement_month',$data);
	}

	function expense_list($ExpData){
		$data=array();
		$expenses=$this->settlement_model->month_txn($ExpData);
		return $expenses;
	}



	function getlist(){
		$this->load->model("common_model");
		$sql="";
		if( !$this->common_model->verify_user() ){
			$sql.=" AND user_id=".$this->session->userdata('fcuser_id')."  ";
		}
		$fdate = str_replace('/','-',$this->input->get('fdate'));
		$txn_date = date('Y-m-d',strtotime($fdate));
		$sql.=" AND transaction_date='".$txn_date."' ";

		$results=$this->settlement_model->record_list($sql);
		$record=array();
		$record['con'] = $this->input->get('con');
		$record['main']=array();
		$record['order_main']=array();
		$sno=0;
		foreach ($results as $result) {

			$txn_type=($result['txn_type']==1)?'<span class="badge badge-success">Credit</span>':'<span class="badge badge-danger">Debit</span>';

			$currency_arr = $this->currency_model->show($result['currency_id']);
			$currency_name = $currency_arr['currency_code'];
            $rate_unit = ($currency_arr['rate_unit']>0)?$currency_arr['rate_unit']:1;
			$client_arr = $this->client_model->show($result['client_id']);
			$client_code = $client_arr['name'].'-'.$client_arr['client_code'];
			$client_group = $client_arr['client_group'];
			$equivalent_credit_avail=0;
			$rqty = $result['quantity']/$rate_unit;

	################### START FIRST DEBIT CALCULATION FOR EACH RESET ####################
	if( $result['is_first_debit'] == 1 ){

		$first_credit_res = $this->db->query(" SELECT transaction_id,stock_margin_value_1 FROM `fc_transaction` WHERE transaction_id > '".$result['transaction_id']."' AND txn_type=1 AND currency_id='".$result['currency_id']."' AND txn_order=0 ORDER BY `transaction_id` ASC LIMIT 1 ");

		$first_credit_row = $first_credit_res->row_array();

		if( $first_credit_res->num_rows() > 0 ) {
			
			if( $result['transaction_id'] < $first_credit_row['transaction_id'] ){

				/* Get before reset of last reset */
				$before_reset_res = $this->db->query(" SELECT transaction_id FROM `fc_transaction` WHERE transaction_id < '".$result['transaction_id']."' AND currency_id='".$result['currency_id']."' AND is_reset=1 AND txn_order=0 AND transaction_id < (SELECT transaction_id FROM `fc_transaction` WHERE currency_id='".$result['currency_id']."' AND is_reset=1 AND txn_order=0 ORDER BY transaction_id DESC LIMIT 1) ORDER BY transaction_id DESC LIMIT 1  ");
				$before_reset_row = $before_reset_res->row_array();

				$bsql="";
				if($before_reset_res->num_rows()>0){
					$bsql=" AND `transaction_id` > '".$before_reset_row['transaction_id']."' ";
				}

				/*sum total debit stock before first credit*/
				$sum_debit_res = $this->db->query(" SELECT SUM(quantity) AS total_debit_stock, SUM(rm_total_rate) AS total_debit_rm FROM `fc_transaction` WHERE 1 ".$bsql." AND `transaction_id` < '".$first_credit_row['transaction_id']."' AND txn_type=2 AND currency_id='".$result['currency_id']."' AND txn_order=0 GROUP BY txn_type  ");
				$sum_debit_row = $sum_debit_res->row_array(); 

				$total_debit_stock = $sum_debit_row['total_debit_stock'];
				$total_debit_rm = $sum_debit_row['total_debit_rm'];

				/* Calculate sum of credit after 1st credit */
				$total_credit_stock=0;
				$total_credit_rm=0;

				$sum_credit_res = $this->db->query(" SELECT quantity,rm_total_rate FROM `fc_transaction` WHERE `transaction_id` >= '".$first_credit_row['transaction_id']."' AND txn_type=1 AND currency_id='".$result['currency_id']."' AND txn_order=0  ");
				$equvalent_credit= false;

				foreach ($sum_credit_res->result_array() as $sum_credit_result) {

						$total_credit_stock+=$sum_credit_result['quantity'];
						$total_credit_rm+=$sum_credit_result['rm_total_rate'];

						if($total_debit_stock == $total_credit_stock){
							$currency_avg_rate = ($total_credit_rm/$total_credit_stock)*$rate_unit;
							$equvalent_credit = true;
							$equivalent_credit_avail=1;
							break;
						}
				}

				if($equvalent_credit==false){
					$currency_avg_rate=$first_credit_row['stock_margin_value_1'];
				}

			} else {
				 $currency_avg_rate = $result['stock_margin_value_1'];
			}

		} else{
			$currency_avg_rate = $result['stock_margin_value_1'];
		}

	} else {
		$currency_avg_rate = $result['stock_margin_value_1'];
		$equivalent_credit_avail=1;
	}
	################### END FIRST DEBIT CALCULATION FOR EACH RESET ######################

		


	        if($currency_avg_rate > 0){
	        	$profit= ($rqty*$result['rm_rate'])-($rqty*$currency_avg_rate);
	        }else{
	           	$profit=0; 
	        }	

        	if( $result['order_id'] == 0 ){ // main record enter by superadmin

				$record['main'][]=array(
					'ref'				=> '<span class="badge badge-default">'.$result['transaction_reference'].'</span>',
					'tdate'				=> date('d-M y',strtotime($result['transaction_date'])),
					'txn_type'			=> $txn_type,
					'client_code'		=> $client_code,
					'currency_name'		=> $currency_name,
					'quantity'			=> number_format($result['quantity'],2),
					'fc_convert'		=> $result['rm_rate'],
					'fc_total_rate' 	=> number_format($result['rm_total_rate'],2),
					'rmout'				=> '',
					'system_convert'	=> $result['stock_margin_value'],
					'currency_avg_rate'	=> $currency_avg_rate,
					'profit'			=> number_format($profit,2),
					'transaction_id'	=> $result['transaction_id'],
					'client_id'			=> $result['client_id'],
					'equivalent_credit_avail' => $equivalent_credit_avail
				);
			}

			if( $result['order_id'] > 0 ){ // if the txn from order

        	$Orderprofit= ($rqty*$result['rm_rate'])-($rqty*$result['stock_margin_value_1']);
        

				$record['order_main'][]=array(
					'ref'				=> '<span class="badge badge-default">'.$result['transaction_reference'].'</span>',
					'tdate'				=> date('d-M y',strtotime($result['transaction_date'])),
					'txn_type'			=> $txn_type,
					'client_code'		=> $client_code,
					'currency_name'		=> $currency_name,
					'quantity'			=> number_format($result['quantity'],2),
					'fc_convert'		=> $result['rm_rate'],
					'fc_total_rate' 	=> number_format($result['rm_total_rate'],2),
					'rmout'				=> '',
					'system_convert'	=> $result['stock_margin_value'],
					'currency_avg_rate'	=> $result['stock_margin_value_1'],
					'profit'			=> number_format($Orderprofit,2),
					'transaction_id'	=> $result['transaction_id'],
					'client_id'			=> $result['client_id']
				);

			}

		}

		$record['deleted'] = array();
		$query = $this->db->query(" SELECT * FROM `fc_transaction_settlement` where currency_id!=1 AND flag=0 AND date(deleted_date)='".$txn_date."' ");
		$results = $query->result_array();

		foreach ($results as $result) {

			$txn_type=($result['txn_type']==1)?'<span class="badge badge-success">Credit</span>':'<span class="badge badge-danger">Debit</span>';

			$currency_arr = $this->currency_model->show($result['currency_id']);
			$currency_name = $currency_arr['currency_code'];
			$rate_unit = ($currency_arr['rate_unit']>0)?$currency_arr['rate_unit']:1;

			$client_arr = $this->client_model->show($result['client_id']);
			$client_code = $client_arr['name'].'-'.$client_arr['client_code'];
			$client_group = $client_arr['client_group'];
			
			$rqty = $result['quantity']/$rate_unit;

        if($result['currency_avg_rate']>0){
        	$profit= ($rqty*$result['rm_rate'])-($rqty*$result['currency_avg_rate']);
        }else{
           $profit=0; 
        }

        if( $result['order_id'] == 0 ){

			$record['deleted'][]=array(
				'ref'				=> '<span class="badge badge-danger">'.$result['transaction_reference'].'</span>',
				'tdate'				=> date('d-M y',strtotime($result['transaction_date'])),
				'txn_type'			=> $txn_type,
				'client_code'		=> $client_code,
				'currency_name'		=> $currency_name,
				'quantity'			=> number_format($result['quantity'],2),
				'fc_convert'		=> $result['rm_rate'],
				'fc_total_rate' 	=> number_format($result['rm_total_rate'],2),
				'rmout'				=> '',
				'system_convert'	=> $result['stock_margin_value'],
				'currency_avg_rate'	=> $result['currency_avg_rate'],
				'profit'			=> number_format($profit,2),
				'transaction_id'	=> $result['transaction_id'],
				'client_id'			=> $result['client_id']
			);

		}else{

			$record['order_deleted'][]=array(
				'ref'				=> '<span class="badge badge-danger">'.$result['transaction_reference'].'</span>',
				'tdate'				=> date('d-M y',strtotime($result['transaction_date'])),
				'txn_type'			=> $txn_type,
				'client_code'		=> $client_code,
				'currency_name'		=> $currency_name,
				'quantity'			=> number_format($result['quantity'],2),
				'fc_convert'		=> $result['rm_rate'],
				'fc_total_rate' 	=> number_format($result['rm_total_rate'],2),
				'rmout'				=> '',
				'system_convert'	=> $result['stock_margin_value'],
				'currency_avg_rate'	=> $result['currency_avg_rate'],
				'profit'			=> number_format($profit,2),
				'transaction_id'	=> $result['transaction_id'],
				'client_id'			=> $result['client_id']
			);
			
		}


		}

		//return $record;
		$data['results']=$record;
		$data['transaction_date'] = $txn_date;
		$this->load->view('ajax/settlement_data',$data);
	}


	function client_info($client_id){
		$data = array();
		$record=$this->client_model->show($client_id);
		$data['result']=$record;
		$currency_arr = $this->currency_model->show($record['currency_id']);
		$data['currency_name'] = $currency_arr['currency_code'];
		echo json_encode($data);
	}

	function dummy(){
		echo $this->settlement_model->dummy();
	}
}
?>