<?php
defined('BASEPATH') OR exit('No direct script access allowed');
class Transaction extends MY_Controller
{
	function __construct(){
		parent::__construct();
		$this->load->model(array('client_model','common_model','currency_model','transaction_model'));
		$this->load->helper('sequency');
	}

	function index($txnid=''){
		$data['page_title']='New Transation';
		$data['message'] = '';
		$csrf = array(
		        'name' => $this->security->get_csrf_token_name(),
		        'hash' => $this->security->get_csrf_hash()
		);
		$data['csrf']=$csrf;
		// $sequence_no=sequency_transaction($this->common_model->nextAutoID('fc_transaction'));
		$sequence_no=sequency_transaction($this->common_model->nextAutoID('fc_txn_sno'));
		$data['transaction_reference']=$sequence_no;
		$data['user_access']=$this->session->userdata('user_access');
		$data['token'] = md5(time().mt_rand(1000,9999).uniqid());

		$data['show_recalculate'] = FALSE;
		if( $this->session->userdata('fcadmin_type') == 1 ){
			$data['show_recalculate'] = TRUE;
		}
		
		$this->load->view('new_transaction',$data);
	}

	function insert(){
		extract($_REQUEST);
		$data = array();
		$data['token'] = md5(time().mt_rand(1000,9999).uniqid());
		if($this->input->server('REQUEST_METHOD')=='POST' && $this->permission->entry_access(4,$this->session->userdata('fcuser_id')) ){
			
			// validatio
			$this->load->library('form_validation');
			$this->form_validation->set_rules('client_id','Client Code','required');
			$this->form_validation->set_rules('transaction_date','Transaction Date','required');
			$this->form_validation->set_rules('transaction_type','Transaction Type','required');
			$this->form_validation->set_rules('currency_code','Currency Code','required');
			$this->form_validation->set_rules('currency_id','Currency Code','required');
			$this->form_validation->set_rules('currency_descr','Currency Description','required');
			$this->form_validation->set_rules('quantity','Quantity','required');
			
			if( $_POST['client_currency_id'] !=1 ){
				$this->form_validation->set_rules('fc_rate','FC Rate','required');
				$this->form_validation->set_rules('fc_convert','Convert','required');
				$this->form_validation->set_rules('fc_total_rate','FC Total','required');
			}
			

			$this->form_validation->set_rules('rm_rate','RM Rate','required');
			$this->form_validation->set_rules('rm_total_rate','RM Total','required');
			$this->form_validation->set_error_delimiters('<p class="text-danger">','</p>');

		if( $this->form_validation->run() ){
			if( $txn_reference == '' ){
				$sequence_no=sequency_transaction($this->common_model->nextAutoID('fc_txn_sno'));
			}else{
				$sequence_no = $txn_reference;
			}
			
			$result=$this->transaction_model->insert($sequence_no);
			if( isset($result['success']) ){
				//$data['message']=$this->alert->success($result['success']);
				$data['message']="";
				$data['transaction_id'] = $result['transaction_id'];
				$data['status'] = 1; // success
				$data['txn_reference'] = $sequence_no;
			}elseif( isset($result['danger']) ){
				$data['message']=$this->alert->warning($result['danger']);
				$data['status'] = 0;
			}
			$this->session->set_flashdata('message',$data['message']);
			
		}else{
			foreach ($_POST as $key => $value) {
				$data['message'][$key] = form_error($key);
			}	
			$data['status'] = 0; // error
		}

		}else{
			$data['message']=$this->alert->warning('Permission Denied');	
			$data['status'] = 0; // error
		}
		$data['csrf']=$this->security->get_csrf_hash();
		$sequence_no=sequency_transaction($this->common_model->nextAutoID('fc_transaction'));
		$data['transaction_reference']=$sequence_no;
		echo json_encode($data);
	}

	function lists(){
		$data['page_title']='Transation List';
		$data['message'] = '';
		$this->load->view('transaction_list',$data);
	}

	function getlist(){
	    $tnxBasedSearch = false;
		$this->load->model("common_model");
		$sql = "";
		if( $this->input->get('ftxn_id') ){
		    $tnxBasedSearch = true;
			//$sql.=" AND transaction_id='".$this->input->get('ftxn_id')."' ";
		}
		if( !$this->common_model->verify_user() ){
		    $tnxBasedSearch = false;
			$sql.=" AND user_id=".$this->session->userdata('fcuser_id')."  ";
		}
		if( $this->input->get('ftxn_type') ){
		    $tnxBasedSearch = false;
			$sql.=" AND txn_type='".$this->input->get('ftxn_type')."' ";
		}
		if( $this->input->get('fgrp_id') ){
		    $tnxBasedSearch = false;
			$sql.=" AND client_id IN ( SELECT client_id FROM `fc_client_code` WHERE parent_id='".$this->input->get('fgrp_id')."') "; 
		}
		if( $this->input->get('fcust_id') ){
		    $tnxBasedSearch = false;
			$sql.=" AND client_id='".$this->input->get('fcust_id')."' "; 
		}
		if( $this->input->get('fcur_id') ){
		    $tnxBasedSearch = false;
			$sql.=" AND currency_id='".$this->input->get('fcur_id')."' "; 
		}
		if( $this->input->get('ftxn_date') ){
		    $tnxBasedSearch = false;
			$fdate = str_replace('/','-',$this->input->get('ftxn_date'));
			$txn_date = date('Y-m-d',strtotime($fdate));
			$sql.=" AND transaction_date='".$txn_date."' "; 
		}
		if( !$this->input->get('foption') ){
			
			if( $this->session->userdata('fcadmin_type') == 1 ){
				//$sql.=" AND currency_id!=17 "; 
				$sql.=" AND date(created_at)='".date('Y-m-d')."' "; 
			} else {
			    $sql.=" AND transaction_date='".date('Y-m-d')."' AND user_id='".$this->session->userdata('fcuser_id')."' "; 
			}
		}else{
			if( $this->session->userdata('fcadmin_type') != 1 ){
				$sql.=" AND user_id='".$this->session->userdata('fcuser_id')."' ";
			}
		}
		
		$class = "";
		if ($tnxBasedSearch) {
		    $query = $this->db->get_where('fc_transaction', array('transaction_id' => $this->input->get('ftxn_id')));
		    $result = $query->result_array();
		    $result = array_shift($result);
		    $sql =" AND transaction_date='".$result['transaction_date']."' ";
		}
		
		$results=$this->transaction_model->record_list($sql);
		$record['data']=array();
		$sno=0;
		foreach ($results as $result) {

			$user_info = $this->common_model->user_profile($result['user_id']);
			$user_name = $user_info['name'];

			$txn_type=($result['txn_type']==1)?'<span class="badge badge-success">Credit</span>':'<span class="badge badge-danger">Debit</span>';

			$currency_arr = $this->currency_model->show($result['currency_id']);
			$currency_name = $currency_arr['currency_code'];

			$client_arr = $this->client_model->show($result['client_id']);
			$client_code = $client_arr['client_code'];
			$client_group = $client_arr['client_group'];

			$is_reset = ($result['is_reset']==1)?'stock_tally':'';
			$txn_group_row = ($result['stock_set']==0)?'stock_not_tally':'';

			// $last_group_row_qu = $this->db->query(" SELECT MAX(transaction_id) AS transaction_id FROM ( SELECT `transaction_id`,txn_group FROM `fc_transaction` UNION SELECT `transaction_id`,txn_group FROM `fc_deleted_transaction` ) AS A WHERE txn_group='".$result['txn_group']."'  ");
			// $last_group_row = $last_group_row_qu->row_array();
			// $last_group_class=($last_group_row['transaction_id'] == $result['transaction_id'])?'last_row':'';

			// $last_group_row_qu = $this->db->query(" SELECT txnno FROM `fc_transaction` WHERE txn_group='".$result['txn_group']."' ORDER BY txnno DESC LIMIT 1  ");
			// $last_group_row = $last_group_row_qu->row_array();
			// $last_group_class=($last_group_row['txnno'] == $result['txnno'])?'last_row':'';

			$action = "";
			if( $result['ttype'] == 1 ){
			    $class = "";
			    if($result['transaction_id'] == $this->input->get('ftxn_id')){
			        $class = "row_highlight";
			    }
				$action = '<a class="update_record badge badge-primary caction '.$class.' " href="javascript:void(0)" data-record_id="'.$result['transaction_id'].'" data-record_flag="'.$result['flag'].'"><i class="fa fa-edit"></i> ACTION</a>';
			}else{
				$action = '<span>---</span>';
			}
			

			$record['data'][]=array(
					'<span class="badge badge-default">'.$result['transaction_reference'].'</span>',
					date('d-m-Y',strtotime($result['transaction_date'])),
					$txn_type,
					$client_group,
					$client_code,
					$result['currency_descr'],
					$currency_name,
					number_format($result['quantity'],2),
					number_format($result['fc_rate'],5),
					number_format($result['fc_total_rate'],2),
					number_format($result['rm_rate'],5),
					number_format($result['rm_total_rate'],2),
					'<span class="badge badge-default">'.$user_name.'</span>',
					$action
			);
		}
		echo json_encode($record);
	}


	function today_deleted_txn(){
		$this->load->model("common_model");
		$sql="";
		if( $this->session->userdata('fcadmin_type') == 1 ){
			$sql.=" AND flag='0' AND transaction_date='".date('Y-m-d')."'  "; 
		}else{
			$sql.=" AND user_id='".$this->session->userdata('fcuser_id')."' ";
		}

		$results=$this->transaction_model->deleted_record($sql);
		$record['data']=array();
		$sno=0;
		foreach ($results as $result) {

			$user_info = $this->common_model->user_profile($result['user_id']);
			$user_name = $user_info['name'];

			$txn_type=($result['txn_type']==1)?'<span class="badge badge-success">Credit</span>':'<span class="badge badge-danger">Debit</span>';

			$currency_arr = $this->currency_model->show($result['currency_id']);
			$currency_name = $currency_arr['currency_code'];

			$client_arr = $this->client_model->show($result['client_id']);
			$client_code = $client_arr['client_code'];
			$client_group = $client_arr['client_group'];

			$action = '<span>---</span>';

			$record['data'][]=array(
					'<span class="badge badge-default">'.$result['transaction_reference'].'</span>',
					date('d-M y',strtotime($result['transaction_date'])),
					$txn_type,
					$client_group,
					$client_code,
					$result['currency_descr'],
					$currency_name,
					number_format($result['quantity'],2),
					number_format($result['fc_rate'],10),
					number_format($result['fc_total_rate'],2),
					number_format($result['rm_rate'],10),
					number_format($result['rm_total_rate'],2),
					'<span class="badge badge-default">'.$user_name.'</span>',
					$action
			);
		}
		echo json_encode($record);
	}

	function show($transaction_id){
		$data['page_title']='View Transation Details';
		$data['message'] = '';
		if( !is_numeric($transaction_id) ){ die('Permission Denied !!!'); }
		$result = $this->transaction_model->show($transaction_id);
		$data['result'] = $result;

		$client_arr = $this->client_model->show($result['client_id']);
		$data['client_code'] = $client_arr['client_code'];
		$data['client_group'] = $client_arr['client_group'];
		$data['client_name'] = $client_arr['name'];

		$currency_arr = $this->currency_model->show($client_arr['currency_id']);
		$data['client_currency_name'] = $currency_arr['currency_code'];
		$data['client_currency_id'] = $client_arr['currency_id'];

		$ccurrency_arr = $this->currency_model->show($result['currency_id']);
		$data['currency_name'] = $ccurrency_arr['currency_code'];

		/* Client account */
		$this->load->model('common_model');
		$data['client_account']=$this->common_model->client_account($result['client_id'],2);
		$data['user_access']=$this->session->userdata('user_access');
		$this->load->view('view_transaction',$data);
	}

	function view_record($client_id){
		if(isset($client_id)){
			$data['con']=$this->input->get('con');
			$record=$this->client_model->show($client_id);
			$data['result']=$record;

			$currency_arr = $this->currency_model->show($record['currency_id']);
			$data['currency_name'] = $currency_arr['currency_code'];

			$csrf = array(
			        'name' => $this->security->get_csrf_token_name(),
			        'hash' => $this->security->get_csrf_hash()
			);
			$data['csrf']=$csrf;
			$this->load->view('ajax/getdata.php',$data);
		}
	}

	

	function delete($transaction_id){
		if($this->input->server('REQUEST_METHOD')=='GET' ){
			if( $this->permission->modify_access(4,$this->session->userdata('fcuser_id')) && $this->session->userdata('fcadmin_type') == 1 ){
				$result=$this->transaction_model->delete($transaction_id);
				if( isset($result['success']) ){
					//$message_status=$this->alert->success($result['success']);
					$message_status='';
				}elseif( isset($result['danger']) ){
					$message_status=$this->alert->danger($result['danger']);
				}
			}else{
					$message_status=$this->alert->danger('Permission Denied !!!');
			}
			echo $message_status;
		}
	}


	function main_account($currency_id){
		$invoice_code= $this->input->get('invoice_code');
		echo $this->common_model->main_account($currency_id,$invoice_code);
	}

	function is_recalculation_require($currency_id){
		$data = array();
		$data['recalculation_require'] = 0; //No
		if( is_numeric($currency_id) ){

			$recall_res = $this->db->query(" SELECT transaction_id FROM `fc_deleted_transaction` 
				WHERE txn_order=0 AND recalculated=0 AND currency_id='$currency_id' 
				AND currency_id!=1 ");
			if($recall_res->num_rows()>0){ 
				if( $this->session->userdata('fcadmin_type') == 1 ){
					$data['message'] = 'Please Re-Calculate The Average !!!';
					$data['recalculation_require'] = 1;
				} else {
					$data['message'] = 'Please ask admin to Re-Calculate !!!';
					$data['recalculation_require'] = 1;
				}
			}
			echo json_encode($data);
		}
	}

}
?>