<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Vehicle extends MY_Controller {

	function __construct(){
		parent::__construct();
		$this->load->model('payroll/vehicle_model');
		$this->load->helper('sequency');
		if( !$this->permission->entry_access(12,$this->session->userdata('fcuser_id')) ){
        	redirect('dashboard'); die();
        }
	}
	public function index()
	{
		$data['page_title']='Vehicle Details';
		$data['user_access']=$this->session->userdata('user_access');
		$data['message'] = "";
		if($this->input->server('REQUEST_METHOD')=='POST' ){
			if( $this->permission->entry_access(12,$this->session->userdata('fcuser_id')) ){
				$result=$this->vehicle_model->insert($this->input->post());
				if( isset($result['success']) ){
					$data['message']=$this->alert->success($result['success']);
				}elseif( isset($result['danger']) ){
					$data['message']=$this->alert->warning($result['danger']);
				}
			}else{
					$data['message']=$this->alert->warning('Permission Denied !!!');
			}
		}

		$data['info']['registration_no'] = "";
		$data['info']['chassis_no'] = "";
		$data['info']['engine_no'] 	= "";
		$data['info']['model'] 		= "";
		$data['info']['owner_name'] = "";
		$data['info']['credit_id'] 	= "";
		$data['info']['debit_id'] 	= "";
		$data['info']['note'] 		= "";
		$data['info']['vehicle_id'] = "";
		$data['credit_cl']     		= "";
		$data['debit_cl']      		= "";
		$data['action']        		= base_url('payroll/vehicle/index/');

		$this->load->view('payroll/vehicle',$data);
	}

	public function edit($id)
	{
		$data['page_title']='Vehicle Details-Edit';
		$data['user_access']=$this->session->userdata('user_access');
		$data['message'] = "";
		if($this->input->server('REQUEST_METHOD')=='POST' ){
			if( $this->permission->modify_access(12,$this->session->userdata('fcuser_id')) ){
				$result=$this->vehicle_model->update($this->input->post());
				if( isset($result['success']) ){
					$data['message']=$this->alert->success($result['success']);
				}elseif( isset($result['danger']) ){
					$data['message']=$this->alert->warning($result['danger']);
				}
			}else{
					$data['message']=$this->alert->warning('Permission Denied !!!');
			}
		}

		$this->load->model(array('client_model'));
		$where = array('vehicle_id'=>$id); 
		$info = $this->vehicle_model->get($where);
		$info = array_shift($info);
		$data['action']   		= base_url('payroll/vehicle/edit/'.$id);
		$data['info'] 			= $info;
		$credit_account        	= $this->client_model->show($info['credit_id']);
		$debit_account         	= $this->client_model->show($info['debit_id']);
		$data['credit_cl']     	= $credit_account['client_code'];
		$data['debit_cl']      	= $debit_account['client_code'];
		$this->load->view('payroll/vehicle',$data);
	}

	function ajax(){
		$this->load->model("common_model");
		$sql = array();
		if( !$this->common_model->verify_user() ){
			//$sql['user_id'] = $this->session->userdata('fcuser_id');
		}
		$this->load->model('client_model');
		$results=$this->vehicle_model->get($sql);
		$record['data']=array();
		if(!empty($results)){
		foreach ($results as $result) {
			
			$credit_account = $this->client_model->show($result['credit_id']);
			$debit_account = $this->client_model->show($result['debit_id']);

			$record['data'][]=array(
					'<span class="badge badge-default">'.$result['registration_no'].'</span>',
					$result['chassis_no'],
					$result['owner_name'],
					'<span class="badge badge-success">'.$credit_account['client_code'].'-'.$credit_account['name'].'</span>',
					'<span class="badge badge-warning">'.$debit_account['client_code'].'-'.$debit_account['name'].'</span>',
					'<a class="update_record btn btn-primary btn-sm caction" href="javascript:void(0)" data-record_id="'.$result['vehicle_id'].'"><i class="fa fa-edit"></i> Action</a>'
			);
		}
		}
		echo json_encode($record);
	}


	function delete($id){
		if($this->input->server('REQUEST_METHOD')=='GET' ){
			if( $this->permission->modify_access(12,$this->session->userdata('fcuser_id')) ){
				$result=$this->vehicle_model->delete($id);
				if( isset($result['success']) ){
					$message_status=$this->alert->success($result['success']);
				}elseif( isset($result['danger']) ){
					$message_status=$this->alert->danger($result['danger']);
				}
			}else{
					$message_status=$this->alert->danger('Permission Denied !!!');
			}
			echo $message_status;
		}
	}

}

/* End of file Advance.php */
/* Location: ./application/controllers/payroll/Advance.php */
?>