<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Vehicle_expense extends MY_Controller {

	function __construct(){
		parent::__construct();
		$this->load->model('payroll/vehicle_expense_model');
		$this->load->model('payroll/vehicle_model');
		$this->load->helper('sequency');
		if( !$this->permission->entry_access(13,$this->session->userdata('fcuser_id')) ){
        	redirect('dashboard'); die();
        }
	}
	public function index()
	{
		$data['page_title']='Vehicle Expense';
		$data['user_access']=$this->session->userdata('user_access');
		$data['message'] = "";
		if($this->input->server('REQUEST_METHOD')=='POST' ){
			if( $this->permission->entry_access(13,$this->session->userdata('fcuser_id')) ){
				$result=$this->vehicle_expense_model->insert($this->input->post());
				if( isset($result['success']) ){
					$data['message']=$this->alert->success($result['success']);
				}elseif( isset($result['danger']) ){
					$data['message']=$this->alert->warning($result['danger']);
				}
			}else{
					$data['message']=$this->alert->warning('Permission Denied !!!');
			}
		}

		$data['registration_no']=$data['vehicle_id']=$data['amount']= "";
		$data['edate']=$data['approved_by']=$data['particulars']="";
		$data['action']        = base_url('payroll/vehicle_expense/index/');
		$data['trigger_account'] = 0;
		$data['expense_id']    = '';
		$data['status']		= "";

		$this->load->view('payroll/vehicle_expense',$data);
	}

	function autocomplete()
	{
		$filter_name=$this->input->get('filter_name');
		$this->load->model('payroll/vehicle_model');
		$results = $this->vehicle_model->vehicle_list($filter_name);
		foreach ($results as $result) {
			$data[] = array( 'registration_no' => $result['registration_no'], 'vehicle_id' => $result['vehicle_id'] );
		}
		echo json_encode($data);
	}

	public function edit($id)
	{
		$data['page_title']='Vehicle Expense - Edit';
		$data['user_access']=$this->session->userdata('user_access');
		$data['message'] = "";
		if($this->input->server('REQUEST_METHOD')=='POST' ){
			if( $this->permission->modify_access(13,$this->session->userdata('fcuser_id')) ){
				$result=$this->vehicle_expense_model->update($this->input->post());
				if( isset($result['success']) ){
					$data['message']=$this->alert->success($result['success']);
				}elseif( isset($result['danger']) ){
					$data['message']=$this->alert->warning($result['danger']);
				}
			}else{
					$data['message']=$this->alert->warning('Permission Denied !!!');
			}
		}

		
		$this->load->model(array('payroll/vehicle_model','client_model'));
		$where = array('expense_id'=>$id); 
		$info = $this->vehicle_expense_model->get($where);
		$info = array_shift($info);
		$where = array();
		$where['vehicle_id'] = $info['vehicle_id'];
		$veh_info = $this->vehicle_model->get($where);
		$veh_info = array_shift($veh_info);
		$data['registration_no'] = $veh_info['registration_no'];
		$data['vehicle_id']   	= $info['vehicle_id'];
		$data['amount']		   = $info['amount'];
		$data['edate']	       = date('d/m/Y',strtotime($info['edate']));
		$data['approved_by']   = $info['approved_by'];
		$data['particulars']   = $info['particulars'];
		$data['status']   	   = $info['status'];
		$data['action']        = base_url('payroll/vehicle_expense/edit/'.$id);
		$data['trigger_account'] = 1;
		$data['expense_id']    = $id;

		$this->load->view('payroll/vehicle_expense',$data);
	}

	function last_ten($id){
		$where = array();
		if( $this->session->userdata('fcadmin_type') != 1 ){
			$where['user_id'] = $this->session->userdata('user_access');
		}
		$where['vehicle_id'] = $id;
		$results = $this->vehicle_expense_model->get($where,5);
		$data = array();
		foreach ($results as $value) {
			$data[] = array(
				"date" 			=> date('d-M Y',strtotime($value['edate'])),
				"amount" 		=> number_format($value['amount'],2),
				"approved_by" 	=> $value['approved_by']
			);
		}
		echo json_encode($data);
	}

	function ajax(){
		$this->load->model("common_model");
		$sql = array();
		if( !$this->common_model->verify_user() ){
			$sql['user_id'] = $this->session->userdata('fcuser_id');
		}

		$results=$this->vehicle_expense_model->get($sql);
		$record['data']=array();
		$this->load->model('payroll/vehicle_model');
		if(!empty($results)){
		foreach ($results as $result) {
			
			if($result['status'] == 1){
				$reference_num = '<span class="badge badge-success">'.$result['reference_num'].'</span>';
			}else{
				$reference_num = '<span class="badge badge-danger">'.$result['reference_num'].'</span>';
			}
			$where = array();
			$where['vehicle_id'] = $result['vehicle_id'];
			$veh_info = $this->vehicle_model->get($where);
			$veh_info = array_shift($veh_info);
			$record['data'][]=array(
					$reference_num,
					date('d-M Y',strtotime($result['edate'])),
					$veh_info['registration_no'],
					'<span class="badge badge-default">'.$result['amount'].'</span>',
					$result['approved_by'],
					$result['particulars'],
					'<a class="update_record btn btn-primary btn-sm caction" href="javascript:void(0)" data-record_id="'.$result['expense_id'].'" data-status="'.$result['status'].'" ><i class="fa fa-edit"></i> Action</a>'
			);
		}
		}
		echo json_encode($record);
	}

	function approval($id){
		if(!is_numeric($id)){ die(); }
		$data = array();
		
		$query = $this->db->query(" SELECT * FROM `fc_vehicle_expense` WHERE expense_id='$id' ");
		$result = $query->row_array();
		$amount = $result['amount'];
		$transaction_date	= $result['edate'];
		$expense_id = $result['expense_id'];
		$flag = 12;
		$cdate = date('Y-m-d H:i:s');
		$seq_type = 10; // for sequence number generation
		$query_status = 1;
		
		$where_v = array('vehicle_id'=>$result['vehicle_id']); 
		$vinfo = $this->vehicle_model->get($where_v);
		$vinfo = array_shift($vinfo);
		$txn_parti = $vinfo['registration_no'].' - '.$result['particulars'];

		$this->load->model('payroll/vehicle_model');
		$where = array();
		$where['vehicle_id'] = $result['vehicle_id'];
		$veh_info = $this->vehicle_model->get($where);
		$veh_info = array_shift($veh_info);
		$credit_id = $veh_info['credit_id'];
		$debit_id  = $veh_info['debit_id'];

		/*START VALIDATION*/
		$elog = 0;
		if(!is_numeric($credit_id) || $credit_id == 0 || !is_numeric($debit_id) || $debit_id == 0){
			$data=['status'=>'success','message'=>'Cant find client info','refresh'=>0];
			++$elog;
		}
		if($amount <= 0  ){
			$data=['status'=>'success','message'=>'Expense Amount must be greater than zero','refresh'=>0];
			++$elog;
		}
		if($result['txn_status'] == 2){
			$data=['status'=>'success','message'=>'Problem in last transaction. Please contact admin','refresh'=>0];
			++$elog;
		}
		$chk_client = $this->db->query(" SELECT client_id FROM `fc_clients` WHERE (client_id='$credit_id' OR client_id='$debit_id') AND currency_id=1  ");
		if($chk_client->num_rows() != 2){
			$data=['status'=>'success','message'=>'Client Account Type must be MYR','refresh'=>0];
			++$elog;
		}

		/*END VALIDATION*/
	if($elog == 0)
	{
		
		if($result['status'] == 0 && $result['txn_status'] == 0){
		
			// To verify that if any flow intruppted. If no intruption then txn_status=1
			$this->db->query(" UPDATE fc_vehicle_expense SET txn_status=2 WHERE 
			expense_id='$expense_id' ");

			$this->db->query(" UPDATE `fc_vehicle_expense` SET status=1 WHERE expense_id='$id' ");

			/* START TRANSACTION AND CLIENT ACCOUNT ENTRY */
			$client_info = array('credit_id' => $credit_id, 'debit_id' => $debit_id, 'amount' => $amount);

			// CREDIT ENTRY
			//$txnno_1 = $this->other_sequence_no($seq_type);
			// Insert new record sequence table and get the latest number and create reference no
			$nm = $this->common_model->sequenceNumberGeneration(9);
			$txnno_1 = newseq($nm, 9);
			$up_1 = $this->db->query(" INSERT INTO `fc_transaction` (`client_id`, `transaction_date`, `txn_type`, `currency_id`, `currency_name`, `currency_rate_unit`,currency_descr, 
				`quantity`, `rm_rate`, `rm_total_rate`, `created_at`, `user_id`,`flag`, 
				other_id, transaction_reference) VALUES ('$credit_id', '$transaction_date', '1', '1', 
				'MYR', '1', '".$txn_parti."',
				'".abs($amount)."', '1', '".abs($amount)."', '".$cdate."', 
				'".$this->session->userdata('fcuser_id')."', '$flag', '$expense_id', '$txnno_1'); ");
			if( $this->db->affected_rows() == 0 ){ ++$query_status; }

			// DEBIT ENTRY
			//$txnno_2 = $this->other_sequence_no($seq_type);
			// Insert new record sequence table and get the latest number and create reference no
			$nm = $this->common_model->sequenceNumberGeneration(9);
			$txnno_2 = newseq($nm, 9);
			$up_2 = $this->db->query(" INSERT INTO `fc_transaction` (`client_id`, `transaction_date`, `txn_type`, `currency_id`, `currency_name`, `currency_rate_unit`,currency_descr, 
				`quantity`, `rm_rate`, `rm_total_rate`, `created_at`, `user_id`,`flag`, 
				other_id, transaction_reference) VALUES ('$debit_id', '$transaction_date', '2', '1', 
				'MYR', '1', '".$txn_parti."',
				'".abs($amount)."', '1', '".abs($amount)."', '".$cdate."', 
				'".$this->session->userdata('fcuser_id')."', '$flag', '$expense_id', '$txnno_2'); ");
			if( $this->db->affected_rows() == 0 ){ ++$query_status; }

			// If two txns are added successfully update client account
			if($query_status == 1){
				$this->client_account_update($client_info);
			$data=['status'=>'success','message'=>'Record has been approved successfully !!!','refresh'=>1];
			$this->db->query(" UPDATE fc_vehicle_expense SET txn_status=1, credit_id='$credit_id', 
				debit_id='$debit_id' WHERE expense_id='$expense_id' ");
			}else{
			$data=['status'=>'success','message'=>'Some problem occur. Please contact admin','refresh'=>0];
			$this->db->query(" UPDATE fc_vehicle_expense SET txn_status=2 WHERE expense_id='$expense_id' ");
			}

			/* END TRANSACTION AND CLIENT ACCOUNT ENTRY */
			
		}else{
			$data=['status'=>'success','message'=>'Record already approved','refresh'=>0];
		}
	}
		echo json_encode($data);
	}


	function delete($id){
		if($this->input->server('REQUEST_METHOD')=='GET' ){
			if( $this->permission->modify_access(9,$this->session->userdata('fcuser_id')) ){
				$result=$this->vehicle_expense_model->delete($id);
				if( isset($result['success']) ){
					$message_status=$this->alert->success($result['success']);
				}elseif( isset($result['danger']) ){
					$message_status=$this->alert->danger($result['danger']);
				}
			}else{
					$message_status=$this->alert->danger('Permission Denied !!!');
			}
			echo $message_status;
		}
	}

	function client_account_update($client_info){
		$credit_id 	= $client_info['credit_id'];
		$debit_id 	= $client_info['debit_id'];
		$amount 	= $client_info['amount'];
		
		/* CREDIT ENTRY */
		$this->db->query(" UPDATE fc_client_account SET rm_credit=rm_credit+$amount WHERE 
		client_id=$credit_id ");

		/* DEBIT ENTRY */
		$this->db->query(" UPDATE fc_client_account SET rm_debit=rm_debit+$amount WHERE 
		client_id=$debit_id ");
	}

	function other_sequence_no($otype){
		$this->db->query(" INSERT INTO `fc_txn_other_sno` (`otype`) VALUES ($otype); ");
		$query = $this->db->query(" SELECT id FROM `fc_txn_other_sno` WHERE otype = '$otype' ");
		$nextId = $query->num_rows()+1;
		$sequence_no = other_transaction($nextId,$otype);
		return $sequence_no;
	}

}

/* End of file Advance.php */
/* Location: ./application/controllers/payroll/Advance.php */
?>