<?php
defined('BASEPATH') OR exit('No direct script access allowed');
class Client_model extends CI_Model
{
	function insert(){
		$result=array();
		extract($_POST);
		$current_date = date('Y-m-d');
		$query01=$this->db->query(" select * from fc_clients where 
		client_code=".$this->db->escape($client_code) );

		if( $query01->num_rows() > 0 ){
			$result['danger']='Sorry... This client code already exist !!!';
		}

		if( $client_group == 'EXPN' && $currency_id != 1 ){
			$result['danger']='Only MYR currency is available for EXPN Group';
		}
			
		$cur_query = $this->db->query(" SELECT currency_id FROM `fc_currency` where currency_code=".$this->db->escape($currency_code)." ");
		$cur_res = $cur_query->row_array();

		if( $cur_query->num_rows() == 0 ){
			$result['danger']='Currency Code Not Exist !!!';
		}

		if( !$result ){

			$currency_id = $cur_res['currency_id'];
			$current_balance=str_replace(",", "", $current_balance);
			$opening_balance=str_replace(",", "", $opening_balance);
			$conv_rate=str_replace(",", "", $conv_rate);
			$cost=str_replace(",", "", $cost);
			$fc_balance=str_replace(",", "", $fc_balance);
			$txn_type='';

			$client_group = $this->db->escape(trim($client_group," "));
			if(!isset($is_supplier)){ $is_supplier=0; }
			
			$query=$this->db->query(" INSERT INTO `fc_clients` (`client_code`,`currency_id`,`name`,
				`address`,`created_at`,`user_id`,client_group,is_supplier) VALUES (".$this->db->escape($client_code).",
				 ".$this->db->escape($currency_id).", ".$this->db->escape($name).",
				 ".$this->db->escape($address).",'".date('Y-m-d H:i:s')."',
				  ".$this->session->userdata('fcuser_id').",$client_group,'$is_supplier') ");
			
			if($this->db->affected_rows()>0){

				$client_id = $this->db->insert_id();
				$ccode_result = $this->client_group_code($client_group);
				$parent_id = $ccode_result['client_id'];

				$currency_row = $this->db->query(" SELECT * FROM `fc_currency` WHERE `currency_id`='$currency_id' ");
				$currency_res = $currency_row->row_array();

				/* client parent code */
				$this->db->query(" insert into fc_client_code set client_id='$client_id', parent_id='$parent_id' ");

				/* create client account if txn type is credit or debit */
				if( $txn_type == 1 ){
					$claccount = array(
									'client_id'		=>	$client_id,
									'currency_id'	=>	$currency_id,
									'fc_credit'		=>	$fc_balance,
									'rm_credit'		=>	$current_balance
								);
					//$this->db->insert('fc_client_account',$claccount);
				}

				if( $txn_type == 2 ){
					$claccount = array(
									'client_id'		=>	$client_id,
									'currency_id'	=>	$currency_id,
									'fc_debit'		=>	$fc_balance,
									'rm_debit'		=>	$current_balance
								);
					//$this->db->insert('fc_client_account',$claccount);
				}

				// Create account
				$this->db->query(" INSERT INTO fc_client_account SET client_id='$client_id', 
				currency_id='$currency_id' ");

				$result['success']='Client Info Added Successfully !!!';
			}else{
				$result['danger']='Sorry... Unable to insert the data !!!';
			}

		}

		return $result;
	}

	function record_list($sql){
		$query=$this->db->query(" SELECT * FROM `fc_clients` where 1 ".$sql." order by client_id desc ");
		return $query->result_array();
	}

	function show($client_id){
		$query=$this->db->query(" SELECT * FROM `fc_clients` where client_id='$client_id' ");
		return $query->row_array();
	}

	function update($client_id){
		$result=array();
		extract($_POST);
		$query01=$this->db->query(" select * from fc_clients where client_code=".$this->db->escape($client_code)." and client_id!=$client_id ");
		if($query01->num_rows()==0){

			$query=$this->db->query(" update `fc_clients` set 
						client_code=".$this->db->escape($client_code).", 
						currency_id=".$this->db->escape($currency_id).",
						name=".$this->db->escape($name).",
						address=".$this->db->escape($address).",
						updated_at='".date('Y-m-d H:i:s')."', 
						user_id=".$this->session->userdata('fcuser_id')." 
						where client_id='$client_id' 
					");
			
			if($query){
				$result['success']='Client Info Updated Successfully !!!';
			}else{
				$result['danger']='Sorry... Unable to update the data !!!';
			}

		}else{
				$result['danger']='Sorry... This code already exist !!!';
		}

		return $result;
	}

	function delete($client_id){

		$code_res = $this->db->query(" SELECT * FROM `fc_client_code` where parent_id='$client_id' ");
		if( $code_res->num_rows() <=1 ){

			$tq = $this->db->get_where('fc_transaction', ['client_id'=>$client_id]);
			if($tq->num_rows() == 0){
				$this->db->query(" DELETE FROM fc_client_account WHERE client_id='$client_id' ");
				$query=$this->db->query(" delete FROM `fc_clients` where client_id='$client_id' AND flag != 1 ");
				if($query){
					$result['success']='Data removed successfully !!!';
				}else{
					$result['danger']='Sorry... Unable to remove this Client !!!';
					//$result = var_dump($this->db->error());
				}
			}else
			{
				$result['danger']='Transaction already exist';
			}
			

		}else{
			$result['danger']='You can not remove Main Group. Please Remove Child first !!!';
		}

		return $result;
	}

	function client_group_code($client_group){
		$query = $this->db->query(" SELECT * FROM `fc_clients` where client_group=$client_group order by client_id asc limit 1 ");
		return $query->row_array();
	}

	function client_account($client_id){
		$query = $this->db->query(" SELECT * FROM `fc_client_account` where client_id=$client_id ");
		return $query->row_array();
	}

	function clients(){
		$query=$this->db->query(" SELECT * FROM `fc_clients` ");
		return $query->result_array();
	}

	function client_parent($client_id){
		$query = $this->db->query(" SELECT parent_id FROM `fc_client_code` where client_id=$client_id ");
		return $query->row_array();
	}
	
	function clientsListByGroup($group)
	{
		$query=$this->db->query(" SELECT * FROM `fc_clients` WHERE client_group='".$group."' ");
		return $query->result_array();
	}

}
?>