<?php
defined('BASEPATH') OR exit('No direct script access allowed');
class Transaction_model extends CI_Model
{
	function insert($sequence_no){
		$result=array();
		$error = 0;
		extract($_POST);
		$current_date = date('Y-m-d');
		$transaction_date=date('Y-m-d',strtotime(str_replace('/','-',$transaction_date)));

		/*Recalculate warning*/
		$recall_res = $this->db->query(" SELECT transaction_id, currency_id FROM `fc_deleted_transaction` WHERE txn_order=0 AND recalculated=0 AND currency_id!=1 AND currency_id='$currency_id' ");
		if($recall_res->num_rows()>0){ 
			++$error;
			$result['danger']='Please update the Stock Average Rate';
		}

		/* validation */
		$client_query = $this->db->query(" SELECT client_id FROM `fc_client_code` where 
			client_id='$client_id'  ");

		/* check token already exist. To prevent duplicate entry */
		$token_query = $this->db->query(" SELECT token FROM `fc_transaction` where token='$token' ");
		if( $token_query->num_rows() > 0 || $token == '' ){
			++$error;
			$result['danger']='Please try again !!!';
		}

		if( $client_query->num_rows() == 0 && $error == 0 ){
			$result['danger']='Please select the client';
			++$error;
		}

		if( ($client_id == '' && $error == 0) || $client_currency_id == '' ){
			$result['danger']='Please select the client';
			++$error;
		}

		if( $currency_id == '' && $error == 0 ){
			$result['danger']='Please select the currency';
			++$error;
		}

		if( $transaction_type == '' && $error == 0 ){
			$result['danger']='Please select the Txn Type';
			++$error;
		}

		$settle_close = $this->db->query(" SELECT transaction_date FROM `fc_transaction` WHERE `flag`=0 AND txn_type=2 AND transaction_date<'".$transaction_date."' AND currency_id !=1  ");
		
		if( $settle_close->num_rows() > 0 && $error == 0 ){
			$result['danger']='Permission Denied. Please Close The Lastday Settlement';
			++$error;
		}

		$eod_check = $this->db->query(" SELECT settlement_id FROM `fc_settlement` WHERE closing_date>='$transaction_date'  ");
		if( $eod_check->num_rows() > 0 && $error == 0 ){
			$result['danger']='Permission Denied. Settlement already closed in this date !!!';
			++$error;
		}

		// check month statement closed
		$month_close = $this->db->query(" SELECT id FROM `fc_settlement_month` WHERE month(month_year)='".date('m',strtotime($transaction_date))."' AND year(month_year)='".date('Y',strtotime($transaction_date))."' ");
		if( $month_close->num_rows() > 0 && $error == 0 ){
			$result['danger']='Month Settlement has been closed. You can not add transactions for the month of '.date('M-Y',strtotime($transaction_date));
			++$error;
		}

		$quantity = str_replace(",","",$quantity);
		$quantity = round($quantity,2);
		if( !is_numeric($quantity) && $error == 0 ){
			$result['danger']='Please Try Again !!!';
			++$error;
		}


		// if currency MYR
		if( $client_currency_id == 1 ){
			$fc_rate=$fc_convert=$fc_total_rate=0;
			$rm_rate = str_replace(",","",$rm_rate);
			$rm_rate = round($rm_rate,10);
			$currency_rate_unit = ($currency_rate_unit>0)?$currency_rate_unit:1;
			$qty_unit = $quantity/$currency_rate_unit;
			$rm_total_rate = round( ($rm_rate*$qty_unit),2 );
		}
		// for other currency
		if( $client_currency_id != 1 ){
			$fc_rate = str_replace(",","",$fc_rate);
			$fc_rate=round($fc_rate,10);
			$fc_convert = str_replace(",","",$fc_convert);
			$fc_convert=round($fc_convert,10);
			$rm_rate = round( ($fc_rate*$fc_convert),10);
			
			$currency_rate_unit = ($currency_rate_unit>0)?$currency_rate_unit:1;
			$client_currency_rate_unit = ($client_currency_rate_unit>0)?$client_currency_rate_unit:1;
			$amountA = $quantity/$currency_rate_unit;
			//$amountB = $client_currency_rate_unit*$fc_rate;
			//$fc_total_rate = round( ($quantity*$fc_rate*$currency_rate_unit),2);
			$rm_total_rate = round( ($amountA*$rm_rate),2);

			$fc_total_rate=round( ($amountA*$fc_rate),2);
		}

		if( ( !is_numeric($fc_total_rate) || !is_numeric($rm_total_rate) ) && $error == 0 ){
			$result['danger']='Please Try Again !!!';
			++$error;
		}

	// client accout
	$client_account_res01=$this->db->query(" SELECT * FROM `fc_client_account` where client_id=".$this->db->escape($client_id)." and currency_id=".$this->db->escape($client_currency_id)." ");
	$client_account_row01=$client_account_res01->row_array();

	// main account
	$main_account_res01=$this->db->query(" SELECT A.currency_id, B.stock_credit,B.stock_debit,B.credit_rm,B.debit_rm,A.rate_unit,B.avg_rate FROM `fc_currency` A LEFT JOIN `fc_main_account` B ON A.currency_id=B.currency_id where A.currency_id=".$this->db->escape($currency_id)." ");
	$main_account_row01=$main_account_res01->row_array();
	$stock_margin_value = ($main_account_row01['avg_rate']>0)?$main_account_row01['avg_rate']:0;
	
			
			if( !$result && $error==0 ){

				$data = array(
					'transaction_reference' => $sequence_no,
					'client_id'				=> $client_id,
					'transaction_date'		=> $transaction_date,
					'txn_type'				=> $transaction_type,
					'currency_id'			=> $currency_id,
					'currency_name'			=> $currency_code,
					'currency_descr'		=> $currency_descr,
					'currency_rate_unit'	=> $currency_rate_unit,
					'client_currency_rate_unit' => $client_currency_rate_unit,
					'quantity'				=> $quantity,
					'rm_rate'				=> $rm_rate,
					'rm_total_rate'			=> $rm_total_rate,
					'fc_rate'				=> $fc_rate,
					'fc_convert'			=> $fc_convert,
					'system_convert'		=> $system_convert,
					'fc_total_rate'			=> $fc_total_rate,
					'created_at'			=> date('Y-m-d H:i:s'),
					'user_id'				=> $this->session->userdata('fcuser_id'),
					'before_fc_credit_c'	=> ($client_account_row01['fc_credit']>0)?$client_account_row01['fc_credit']:0,
					'before_fc_debit_c'		=> ($client_account_row01['fc_debit']>0)?$client_account_row01['fc_debit']:0,
					'before_rm_credit_c'	=> ($client_account_row01['rm_credit']>0)?$client_account_row01['rm_credit']:0,
					'before_rm_debit_c'		=> ($client_account_row01['rm_debit']>0)?$client_account_row01['rm_debit']:0,
					'before_stock_credit_m'	=> ($main_account_row01['stock_credit']>0)?$main_account_row01['stock_credit']:0,
					'before_stock_debit_m'	=> ($main_account_row01['stock_debit']>0)?$main_account_row01['stock_debit']:0,
					'before_credit_rm_m'	=> ($main_account_row01['credit_rm']>0)?
						$main_account_row01['credit_rm']:0,
					'before_debit_rm_m'		=> ($main_account_row01['debit_rm']>0)?$main_account_row01['debit_rm']:0,
					'stock_margin_value'    => $stock_margin_value,
					'token'					=> $token
				);

				$up = $this->db->insert("fc_transaction",$data);
				
				if($up){

                    $transaction_id=$this->db->insert_id();

                    // for sequence no generation
                    if($txn_reference == '') {
                    	$this->db->query(" INSERT INTO `fc_txn_sno` (`transaction_id`, `title`) VALUES ($transaction_id, 'A'); ");	
                    }
                    

					/* create account if not available otherwise update based client currency only*/
					$client_account_res = $this->db->query(" SELECT client_id FROM `fc_client_account` where client_id='$client_id' and currency_id='$client_currency_id' ");

					if( $client_account_res->num_rows() > 0 ){ // update

						/* credit method */
						if( $transaction_type == 1 ){
							$this->db->query(" update fc_client_account set 
									rm_credit=rm_credit+$rm_total_rate, 
									fc_credit=fc_credit+$fc_total_rate
									where client_id='$client_id' and currency_id='$client_currency_id'
									");
						}

						// debit method
						if( $transaction_type == 2 ){
							$this->db->query(" update fc_client_account set 
									rm_debit=rm_debit+$rm_total_rate, 
									fc_debit=fc_debit+$fc_total_rate
									where client_id='$client_id' and currency_id='$client_currency_id'
									");	
						}

					} else { // create

						/* credit method */
						if( $transaction_type == 1 ){
							$this->db->query(" insert into fc_client_account set 
										rm_credit=$rm_total_rate, 
										fc_credit=$fc_total_rate,
										client_id='$client_id', 
										currency_id='$client_currency_id'
									");
						}

						// debit method
						if( $transaction_type == 2 ){
							$this->db->query(" insert into fc_client_account set 
										rm_debit=$rm_total_rate, 
										fc_debit=$fc_total_rate,
										client_id='$client_id', 
										currency_id='$client_currency_id'
									");
						}

					}

					// main account based on currency i.e choosen while txn
					$main_account_res = $this->db->query(" SELECT currency_id FROM `fc_main_account` where currency_id='$currency_id' ");

					if( $main_account_res->num_rows() > 0 ){ // update
						
						/* credit method */
						if( $transaction_type == 1 ){
							$this->db->query(" update fc_main_account set 
									stock_credit=stock_credit+$quantity, 
									credit_rm=credit_rm+$rm_total_rate, 
									updated_at='".date('Y-m-d H:i:s')."'
							 		where currency_id='$currency_id' ");
						}

						// debit method
						if( $transaction_type == 2 ){
							$this->db->query(" update fc_main_account set 
									stock_debit=stock_debit+$quantity, 
									debit_rm=debit_rm+$rm_total_rate, 
									updated_at='".date('Y-m-d H:i:s')."'
							 		where currency_id='$currency_id' ");
						}
					
					} else { // create

						/* credit method */
						if( $transaction_type == 1 ){
							$this->db->query(" insert into fc_main_account set 
										stock_credit=$quantity, 
										credit_rm=$rm_total_rate,
										currency_id='$currency_id'
									");
						}

						// debit method
						if( $transaction_type == 2 ){
							$this->db->query(" insert into fc_main_account set 
										stock_debit=$quantity, 
										debit_rm=$rm_total_rate,
										currency_id='$currency_id'
									");
						}
					}

					/*START CURRENCY STOCK MAINTENANCE*/

					/* credit method */
					if( $transaction_type == 1 ){
						$this->db->query(" UPDATE fc_currency set 
								stock_credit=stock_credit+$quantity, 
								credit_rm=credit_rm+$rm_total_rate
								where currency_id='$currency_id' ");
					}

					/* debit method */
					if( $transaction_type == 2 ){
						$this->db->query(" UPDATE fc_currency set 
								stock_debit=stock_debit+$quantity, 
								debit_rm=debit_rm+$rm_total_rate
						 		where currency_id='$currency_id' ");
					}

					/*END CURRENCY STOCK MAINTENANCE*/

					// update currency avg rate 
					$this->update_currency_rate($currency_id,0,$transaction_id);
					
					$result['transaction_id'] = $transaction_id;
					$result['success']='Data Added Successfully !!!';

				}else{
					$result['danger']='Sorry... Unable to insert the transaction !!!';
				}
			}
		
		return $result;
	}

	
	function delete($transaction_id){
		$error = 0;
		$txn_query = $this->db->query(" SELECT * FROM `fc_transaction` WHERE 
			transaction_id='$transaction_id'  ");
		$txn_res = $txn_query->row_array();

		$txn_date_1 = $txn_res['transaction_date'];
		$amount_array = array();
		$currency_id = $txn_res['currency_id'];
		$txn_type = $txn_res['txn_type'];
		$client_id = $txn_res['client_id'];
		$txn_flag = $txn_res['flag'];
		$txn_order = $txn_res['txn_order'];
		$amount_array = array(
							'currency_id'		=>	$txn_res['currency_id'],
							'quantity'			=>	$txn_res['quantity'],
							'fc_total_rate'		=>	$txn_res['fc_total_rate'],
							'rm_total_rate'		=>	$txn_res['rm_total_rate']
						);

		if( $txn_query->num_rows() == 0 ){ redirect('dashboard','refresh'); die(); }

		/* Check if txn is first credit after reset.... only for main txn */
		if( $txn_res['txn_order'] == 0 && $txn_res['txn_type'] == 1 && $currency_id != 1 ){

			$is_debit_txn = $this->db->query(" SELECT is_reset FROM `fc_transaction` WHERE  
				txn_order=0 AND currency_id='".$currency_id."' AND transaction_id > '$transaction_id' 
				AND txn_type=2 ");

			if( $is_debit_txn->num_rows() > 0 ){
				++$error;
				$result['danger']='Please delete the <b>Debit transactions first</b>';
			}

		}

		/*Recalculate warning*/
		$recall_res = $this->db->query(" SELECT transaction_id, currency_id FROM `fc_deleted_transaction` WHERE txn_order=0 AND recalculated=0 AND currency_id!=1 ");
		if($recall_res->num_rows()>0){ 
			++$error;
			$result['danger']='Please update the Stock Average Rate and Try Again !!!';
		}

		if( $txn_res['flag'] > 1  ){
			++$error;
			$result['danger']='Permission Denied. We can not remove this transition.';
		}

		$settle_query = $this->db->query(" SELECT id FROM `fc_settlement_month` WHERE month(month_year)='".date('m',strtotime($txn_date_1))."' AND year(month_year)='".date('Y',strtotime($txn_date_1))."'  ");
		if( $settle_query->num_rows() > 0 ) {
			++$error;
			$result['danger']='Sorry. We can not remove this record. Bcz its moved to monthly settlement';
		}

		/* START CHECK STOCK IS AVAILABLE IN CURRENCY AND CLIENT ACCOUNT */
		if( $txn_type == 1 ){

			$cl_acc_amount_c = $this->db->query(" SELECT client_id FROM `fc_client_account` WHERE
			`client_id`='$client_id' AND fc_credit < '".$txn_res['fc_total_rate']."' AND 
			rm_credit < '".$txn_res['rm_total_rate']."' ");

			$cr_acc_amount_c = $this->db->query(" SELECT currency_id FROM `fc_currency` WHERE currency_id='$currency_id' AND stock_credit < '".$txn_res['quantity']."' AND 
			    credit_rm < '".$txn_res['rm_total_rate']."' ");

			if( $cl_acc_amount_c->num_rows() > 0 || $cr_acc_amount_c->num_rows() > 0 )
			{
				++$error;
				$result['danger']='Permission Denied !!!';
			}
		}

		if( $txn_type == 2 ){

			$cl_acc_amount_d = $this->db->query(" SELECT client_id FROM `fc_client_account` WHERE
			`client_id`='$client_id' AND fc_debit < '".$txn_res['fc_total_rate']."' AND 
			rm_debit < '".$txn_res['rm_total_rate']."' ");

			$cr_acc_amount_d = $this->db->query(" SELECT currency_id FROM `fc_currency` WHERE currency_id='$currency_id' AND stock_debit < '".$txn_res['quantity']."' AND 
			    debit_rm < '".$txn_res['rm_total_rate']."' ");

			if( $cl_acc_amount_d->num_rows() > 0 || $cr_acc_amount_d->num_rows() > 0 )
			{
				++$error;
				$result['danger']='Permission Denied !!!';
			}
		}
		/* END CHECK STOCK IS AVAILABLE IN CURRENCY AND CLIENT ACCOUNT */



		

	if( empty($result) && $error == 0 ){

		// Get txn record to minus the profit amount which already moved to settlement

		if( $txn_flag == 1 ){

			$tnx_query = $this->db->query(" INSERT INTO `fc_transaction_settlement` (`transaction_id`, `flag`, `deleted_date`, `deleted_user_id`, `transaction_reference`, `client_id`, `transaction_date`, `txn_type`, `currency_id`, `currency_name`, `currency_descr`, `currency_rate_unit`, `client_currency_rate_unit`, `quantity`, `fc_rate`, `fc_convert`, `system_convert`,`currency_avg_rate`, `fc_total_rate`, `rm_rate`, `rm_total_rate`, `before_fc_credit_c`, `before_fc_debit_c`, `before_rm_credit_c`, `before_rm_debit_c`, `before_stock_credit_m`, `before_stock_debit_m`, `before_credit_rm_m`, `before_debit_rm_m`, `stock_margin_value`, `created_at`, `updated_at`, `user_id`,`order_id`,stock_margin_value_1,txn_order,settlement_id) SELECT `transaction_id`,'0' AS `flag`, '".date('Y-m-d H:i:s')."' AS `deleted_date`, '".$this->session->userdata('fcuser_id')."' AS `deleted_user_id`, `transaction_reference`, `client_id`, `transaction_date`, `txn_type`, `currency_id`, `currency_name`, `currency_descr`, `currency_rate_unit`, `client_currency_rate_unit`, `quantity`, `fc_rate`, `fc_convert`, `system_convert`,`currency_avg_rate`, `fc_total_rate`, `rm_rate`, `rm_total_rate`, `before_fc_credit_c`, `before_fc_debit_c`, `before_rm_credit_c`, `before_rm_debit_c`, `before_stock_credit_m`, `before_stock_debit_m`, `before_credit_rm_m`, `before_debit_rm_m`, `stock_margin_value`, `created_at`, `updated_at`, `user_id`,`order_id`, stock_margin_value_1,txn_order,settlement_id FROM `fc_transaction` WHERE transaction_id='$transaction_id' ");

		}

		/*if the txn is debit*/
		if( $txn_type == 2 ){

			$query=$this->db->query(" delete FROM `fc_transaction` where 
				transaction_id='$transaction_id' ");

			if($query){
			
			// remove amount from account
			$this->client_account_deduction($txn_type,$client_id,$amount_array,$txn_flag,$txn_order);
			
			if($txn_order==0){
				$result['success']='Transation removed successfully. Please Re-Calculate The Average';
			}else{
				$result['success']='Transation removed successfully. Please check the Settlement !!!';
			}
			
			
			}else{
				$result['danger']='Sorry. Unable To Remove This Transaction !!!';
			}

		}


		/* if txn type is credit */
		if( $txn_type == 1 ){

			$query=$this->db->query(" delete FROM `fc_transaction` where 
				transaction_id='$transaction_id' ");

			if($query){

			// remove amount from account
			$this->client_account_deduction($txn_type,$client_id,$amount_array,$txn_flag,$txn_order);
			if($txn_order==0){
				$result['success']='Transation removed successfully. Please Re-Calculate The Average';
			}else{
				$result['success']='Transation removed successfully.';
			}
			
			}else{
				$result['danger']='Sorry. Unable To Remove This Transaction !!!';
			}
		}
	
	}

	return $result;

}


	function record_list($sql=null){
		$query=$this->db->query(" 
			SELECT * FROM (SELECT `transaction_id`, `token`, `transaction_reference`, `client_id`, `transaction_date`, `txn_type`, `currency_id`, `currency_name`, `currency_descr`, `currency_rate_unit`, `client_currency_rate_unit`, `quantity`, `fc_rate`, `fc_convert`, `system_convert`, `fc_total_rate`, `rm_rate`, `rm_total_rate`, `before_fc_credit_c`, `before_fc_debit_c`, `before_rm_credit_c`, `before_rm_debit_c`, `before_stock_credit_m`, `before_stock_debit_m`, `before_credit_rm_m`, `before_debit_rm_m`, `stock_margin_value`, `created_at`, `updated_at`, `user_id`, `flag`, `mflag`, `txn_order`, `order_id`, `settlement_id`,'1' AS ttype FROM `fc_transaction`
			UNION
			SELECT `transaction_id`, `token`, `transaction_reference`, `client_id`, `transaction_date`, `txn_type`, `currency_id`, `currency_name`, `currency_descr`, `currency_rate_unit`, `client_currency_rate_unit`, `quantity`, `fc_rate`, `fc_convert`, `system_convert`, `fc_total_rate`, `rm_rate`, `rm_total_rate`, `before_fc_credit_c`, `before_fc_debit_c`, `before_rm_credit_c`, `before_rm_debit_c`, `before_stock_credit_m`, `before_stock_debit_m`, `before_credit_rm_m`, `before_debit_rm_m`, `stock_margin_value`, `created_at`, `updated_at`, `user_id`, `flag`, `mflag`, `txn_order`, `order_id`, `settlement_id`,'2' AS ttype FROM `fc_deleted_transaction` ) AS A WHERE 1 ".$sql." order by transaction_id desc
			");
		return $query->result_array();
	}

	function show($transaction_id){
		$query=$this->db->query(" SELECT * FROM `fc_transaction` where transaction_id='$transaction_id' ");
		return $query->row_array();
	}



	function client_account_deduction($txn_type,$client_id,$amount_array,$flag,$txn_order){

		$client_query = $this->db->query(" SELECT currency_id FROM `fc_clients` 
		where client_id='$client_id'  ");
		$client_res = $client_query->row_array();
		$client_currency_id = $client_res['currency_id'];

		$fc_total_rate = $amount_array['fc_total_rate'];
		$rm_total_rate = $amount_array['rm_total_rate'];
		$quantity = $amount_array['quantity'];
		$currency_id = $amount_array['currency_id'];

		if( $txn_type ==1 ) { //credit

			/* client Account */
			$this->db->query(" UPDATE `fc_client_account` SET fc_credit=fc_credit-$fc_total_rate,
			rm_credit=rm_credit-$rm_total_rate WHERE currency_id='$client_currency_id' 
			AND client_id='$client_id' ");

			if( ($flag == 0 || $flag == 1) && $txn_order == 0 ){
				
				/* currency account */
				// $this->db->query(" UPDATE `fc_main_account` SET stock_credit=stock_credit-$quantity,
				// credit_rm=credit_rm-$rm_total_rate WHERE currency_id='$currency_id' ");

				/*CURRENCY STOCK*/
				$this->db->query(" UPDATE `fc_currency` SET stock_credit=stock_credit-$quantity,
				credit_rm=credit_rm-$rm_total_rate WHERE currency_id='$currency_id' ");

				// update currency avg rate
				//$this->update_currency_rate_delete($txn_type,$flag,$amount_array);

			}

		}

		if( $txn_type ==2 ) { //debit

			/* client Account */
			$this->db->query(" UPDATE `fc_client_account` SET fc_debit=fc_debit-$fc_total_rate,
			rm_debit=rm_debit-$rm_total_rate WHERE currency_id='$client_currency_id' AND client_id='$client_id' ");

			if( ($flag == 0 || $flag == 1) && $txn_order == 0 ){
				
				/* currency account */
				// $this->db->query(" UPDATE `fc_main_account` SET stock_debit=stock_debit-$quantity,
				// debit_rm=debit_rm-$rm_total_rate WHERE currency_id='$currency_id' ");

				/*CURRENCY STOCK*/
				$this->db->query(" UPDATE `fc_currency` SET stock_debit=stock_debit-$quantity,
				debit_rm=debit_rm-$rm_total_rate WHERE currency_id='$currency_id' ");

				// update currency avg rate
				//$this->update_currency_rate_delete($txn_type,$flag,$amount_array);

			}

		}

	}
	// dont use this method
	function update_currency_rate_delete($txn_type,$flag,$amount_array){


		$fc_total_rate = $amount_array['fc_total_rate'];
		$rm_total_rate = $amount_array['rm_total_rate'];
		$quantity = $amount_array['quantity'];
		$currency_id = $amount_array['currency_id'];

		$credit_res = $this->db->query(" SELECT if( SUM(quantity) > 0, SUM(quantity),0 ) AS quantity, if( SUM(rm_total_rate) > 0, SUM(rm_total_rate),0 ) AS rm_total_rate FROM `fc_transaction` WHERE flag=0 AND txn_type=1 AND currency_id=$currency_id ");
		$credit_row = $credit_res->row_array();

		$stock_credit = $credit_row['quantity'];
		$credit_rm = $credit_row['rm_total_rate'];

		$debit_res = $this->db->query(" SELECT if( SUM(quantity) > 0, SUM(quantity),0 ) AS quantity, if( SUM(rm_total_rate) > 0, SUM(rm_total_rate),0 ) AS rm_total_rate FROM `fc_transaction` WHERE flag=0 AND txn_type=2 AND currency_id=$currency_id ");
		$debit_row = $debit_res->row_array();

		$stock_debit = $debit_row['quantity'];
		$debit_rm = $debit_row['rm_total_rate'];

		$this->db->query(" update `fc_main_account` set stock_credit=$stock_credit, stock_debit=$stock_debit, credit_rm=$credit_rm, debit_rm=$debit_rm where currency_id=".$this->db->escape($currency_id)." ");

		/* if the txn is already settled */
		if( $flag == 1 ){
			
			if( $txn_type == 1 ){

				$this->db->query(" update `fc_main_account` set stock_credit=stock_credit-$quantity, credit_rm=credit_rm-$rm_total_rate where currency_id=".$currency_id." ");

				$this->update_currency_rate($currency_id);
			}

			if( $txn_type == 2 ){

				$this->db->query(" update `fc_main_account` set stock_debit=stock_debit-$quantity, debit_rm=debit_rm-$rm_total_rate where currency_id=".$currency_id." ");

				$this->update_currency_rate($currency_id);
			}

		}

		/* if the txn is not settled */
		if( $flag == 0 ){
			// update avg rate
			$this->update_currency_rate($currency_id,$txn_type);
		}


	}


	function update_currency_rate($currency_id,$txn_type=0,$transaction_id=0){ // check Dashboard ctrl

		/* STRAT update avg rate */
		$main_account_res01=$this->db->query(" SELECT A.currency_id, B.stock_credit,B.stock_debit,B.credit_rm,B.debit_rm,A.rate_unit,B.avg_rate FROM `fc_currency` A LEFT JOIN `fc_main_account` B ON A.currency_id=B.currency_id where A.currency_id=".$currency_id." ");
		$main_account_row01=$main_account_res01->row_array();

		$stock_credit = $main_account_row01['stock_credit'];
		$credit_rm = $main_account_row01['credit_rm'];
		$stock_debit = $main_account_row01['stock_debit'];
		$debit_rm = $main_account_row01['debit_rm'];
		$currrate_unit = ($main_account_row01['rate_unit']>0)?$main_account_row01['rate_unit']:1;
		$current_date = date('Y-m-d');
		$currency_avg_rate_1 = $main_account_row01['avg_rate'];
		$avg_updated = false;
		/*
			Condition - 1
			c = +
			d = +
		*/
		if( $stock_credit >= 0 && $stock_debit >= 0 ){

			if( $stock_credit == $stock_debit ) {
				$avg_rate = 0;
				$this->db->query(" update `fc_main_account` set stock_credit=0, stock_debit=0, credit_rm=0, debit_rm=0, avg_rate=0 where currency_id=".$this->db->escape($currency_id)." ");
				if($transaction_id>0){
					$this->db->query(" UPDATE `fc_transaction` SET is_reset=1, stock_margin_value_1='$currency_avg_rate_1'  WHERE transaction_id='$transaction_id' ");
					$avg_updated = true;
				}

			}elseif ( $stock_credit == 0 && $stock_debit > 0 ) {
				
				$avg_rate = ($stock_debit>0) ? ($debit_rm/$stock_debit):0;
				$avg_rate = abs($avg_rate*$currrate_unit);

				$this->db->query(" update `fc_main_account` set avg_rate=$avg_rate 
    			where currency_id=".$this->db->escape($currency_id)." ");

    			if($transaction_id>0){
					$this->db->query(" UPDATE `fc_transaction` SET is_first_debit=1 WHERE transaction_id='$transaction_id' ");
				}

			}elseif ( $stock_credit > 0 && $stock_debit == 0 ) {
				
				$avg_rate = ($stock_credit>0) ? ($credit_rm/$stock_credit):0;
				$avg_rate = abs($avg_rate*$currrate_unit);

				$this->db->query(" update `fc_main_account` set avg_rate=$avg_rate 
    			where currency_id=".$this->db->escape($currency_id)." ");

			}elseif ( $stock_credit > 0 && $stock_debit > 0 ) {
				
				$avg_rate = ($stock_credit>0) ? ($credit_rm/$stock_credit):0;
				$avg_rate = abs($avg_rate*$currrate_unit);

				$this->db->query(" update `fc_main_account` set avg_rate=$avg_rate 
    			where currency_id=".$this->db->escape($currency_id)." ");

			}

		}elseif ( $stock_credit >= 0 && $stock_debit < 0 ) {

			/*
				Condition - 2
				c = +
				d = -
			*/
			if( $stock_credit == 0 && $stock_debit < 0 ) {

				$avg_rate =  $debit_rm/$stock_debit;
				$avg_rate = abs($avg_rate*$currrate_unit);

				$this->db->query(" update `fc_main_account` set avg_rate=$avg_rate 
    			where currency_id=".$this->db->escape($currency_id)." ");

			}elseif ( $stock_credit > 0 && $stock_debit < 0 ) {
				
				$avg_rate = ($stock_credit>0) ? ($credit_rm/$stock_credit):0;
				$avg_rate = abs($avg_rate*$currrate_unit);

				$this->db->query(" update `fc_main_account` set avg_rate=$avg_rate 
    			where currency_id=".$this->db->escape($currency_id)." ");

			}

			
		}elseif ( $stock_credit < 0 && $stock_debit >= 0 ) {
			/*
				Condition - 3
				c = -
				d = +
			*/
			$avg_rate = $credit_rm/$stock_credit;
			$avg_rate = abs($avg_rate*$currrate_unit);

			$this->db->query(" update `fc_main_account` set avg_rate=$avg_rate 
			where currency_id=".$this->db->escape($currency_id)." ");

		}elseif ( $stock_credit < 0 && $stock_debit < 0 ) {

			/*
				Condition - 4
				c = -
				d = -
			*/
			$avg_rate = $credit_rm/$stock_credit;
			$avg_rate = abs($avg_rate*$currrate_unit);

			$this->db->query(" update `fc_main_account` set avg_rate=$avg_rate 
			where currency_id=".$this->db->escape($currency_id)." ");
			
		}

		/* END  update avg rate */

		// update currency avg rate
		if( $txn_type == 1 ){
			// $this->db->query(" UPDATE `fc_transaction` SET stock_margin_value='$avg_rate' WHERE currency_id=$currency_id AND flag=0 AND transaction_date='$current_date' ");
		}

		$this->db->query(" UPDATE `fc_currency` set currency_avg_rate=$avg_rate 
			where currency_id=".$this->db->escape($currency_id)." ");

		if( $transaction_id > 0  && $avg_updated == false ){
			$this->db->query(" UPDATE `fc_transaction` SET  stock_margin_value_1='$avg_rate' WHERE transaction_id=$transaction_id ");
		}
	}


	// function currency_account_summation(){

	// 	$credit_res = $this->db->query(" SELECT SUM(quantity) AS quantity, SUM(rm_total_rate) AS rm_total_rate FROM `fc_transaction` WHERE txn_type=1 AND currency_id='$currency_id'  ");
	// 	$credit_row = $credit_res->row_array;

	// 	$stock_credit = $credit_row['quantity'];
	// 	$credit_rm    = $credit_row['rm_total_rate'];

	// 	$debit_res = $this->db->query(" SELECT SUM(quantity) AS quantity, SUM(rm_total_rate) AS rm_total_rate FROM `fc_transaction` WHERE txn_type=2 AND currency_id='$currency_id'  ");
	// 	$debit_row = $debit_res->row_array;

	// 	$stock_debit = $debit_row['quantity'];
	// 	$debit_rm    = $debit_row['rm_total_rate'];

	// 	$this->db->query(" delete from fc_currency_account where currency_id='$currency_id' ");

	// 	$this->db->query(" insert into `fc_currency_account` (currency_id,stock_credit,stock_debit,credit_rm,debit_rm)values('$currency_id','$stock_credit','$stock_debit','$credit_rm','$debit_rm') ");

	// }

}
?>